### Overview

This is the global documentation for Stage.
                                         One user may has multiple Accounts, and one account may is associated with multiple users
There are a database named **StageSessions** to manipulate the sessions.
    There are a database named **StageAccount** that is associated with users and accounts
Each client has a database of their own
There is a 2-phase database switch. If the user is not authenticated then all the requests use the **StageAccount**. otherwise
    all requests use the database **StageClient** ( where StageClient could be in a diferent database name)

### Requirements

    - PHP 5.4.x or higher

### Package name

    **stage/stage**

### Installation

    Create  a file with the name **composer.json**

```json
{
    "minimum-stability" : "dev",
    "repositories": [{
    "type": "composer",
    "url": "http://admin:adminpass@code.climbers.toran.proxy.youon.co/repo/private/"
},
    {
        "type": "composer",
        "url": "http://admin:adminpass@code.climbers.toran.proxy.youon.co/repo/packagist/"
    }]
}
```

and then $ composer require stage\stage

### Usage

    To use the stage you need first to write this code to make things work.
        This code is like an initialization/bootstrap code where the Stage instance is the top class

```php

    require_once 'bootstrap.php';

    use Stage\Sps;
    use Stage\Stage;    
    use Service\Connection;
    use Stage\Paths\Storage;
    use Stage\StoredProcedure\Manager as StoredProcedureManager;

    $credentials = [
        'host' => "xxx",
        'dbname' => "yyy",
        'username' => "zzz",
        'password' => "www"
    ];


    // 1. Create a new Stage instance ( Singleton Pattern )
    $stage = Stage::getInstance();

    // Create connections instances
    $default = new Connection($credentials);
    $client = new Connection($clientCredentials);
    $leads = new Connection($leadsCredentials);

    // Add the connections to the stage instance and set the keys for that connections
    $stage->addConnection('default', $default);
    $stage->addConnection('client', $client);
    $stage->addConnection('leads', $leads);

    // Set the Stage stored procedures
    $stageInstance->setSps(Sps::load());

    // Set the StoredProcedure\Manager instance
    $spm = StoredProcedureManager::getInstance();
    $stage->setStoredProcedureManager($spm);

    $assetsInstance = Asset::getInstance();
    $assetsInstance->add($assets);

    $storageInstance = Storage::getInstance();
    $storageInstance->add($storage);


```

### Changelog