<?php

    require_once '../bootstrap.php';

    use Stage\Stage as Stage;
    use Stage\Industry as Industry;
    use Stage\Country as Country;
    use Stage\Account\Account as Account;

    $stageInstance = Stage::getInstance();


    // Get the list of available Timezones
    $timeZones = DateTimeZone::listIdentifiers();
    // print_r($timeZones);

    $dateTimeZoneLisbon = new DateTimeZone("Europe/Lisbon");
    $dateTimeZoneMadrid = new DateTimeZone("Europe/Madrid");

    $dateTimeLisbon = new DateTime("now", $dateTimeZoneLisbon);
    $dateTimeMadrid = new DateTime("now", $dateTimeZoneMadrid);

    $timeOffset = $dateTimeZoneMadrid->getOffset($dateTimeLisbon);

    //var_dump($timeOffset);

    $industries = Industry::all('pt');
    //print_r($industries);

    \Stage\Events\Event::listen('account.created', function ($account) {
        echo "Account created";
        print_r($account);
    });


    $account = new Account();
    $account->setCompanyName("SomeTitle");
    $account->setPhone(2232223);
    $account->setToken("2312DFRasd3ed3d");
    $account->setEmail("21101032223323333633@gmail.com");
    $account->setCountryIso("pt");
    $account->setAddress("someAdress");
    $account->setIdIndustryType($industries[0]->getId());
    $account->setWebsite("wwww.youtube.com");
    $account->setTimezone($timeOffset);

    try {
        $account->save();
        //$account = Account::find(10,Account::ID);
        //$industry = $account->getIndustry('pt');
        //print_r($industry->getDescription());
    } catch (Exception $e) {
        echo $e->getMessage();
    }

    print_r(Stage::getInstance()->getStoredProcedureManager()->getLast());

    $temp = [];
    $countries = Country::all('pt');

    foreach ($countries as $country) {
        $temp[] = $country->toArray();
    }


    //echo json_encode($temp);

//    print_r($countries[0]->toJson());
