<?php

    require_once '../bootstrap.php';

    use Stage\Asset\Directory;
    use Stage\Asset\Query;

    try {

        // Put in global
        $idDirectory = 0;
        $query = new Query();
        $query->term = "";

//      Search in fields  all, name, description
//        $query->by = Query::ALL;
//        $query->by = Query::NAME;
//        $query->by = Query::DESCRIPTION;

//      Search filter by month, year, tags, mime_type, dimensions
//        $query->by = Query::MONTH;
//        $query->filter = "2017-01-05";
//        $query->by = Query::YEAR;
//        $query->filter = "2017-03-05";
//        $query->by = Query::TAGS;
//        $query->filter = "green%purple";
        $query->by = Query::MIME_TYPE;
        $query->filter = "image/png";
//        $query->by = Query::DIMENSION;
//        $query->filter = "320x240";
//        $query->by = Query::SIZE;
//        $query->fromSize = 1;       // Must be in bytes
//        $query->toSize = 500;       // Must be in bytes

        $query->from = 0;
        $query->to = -1;

        $assets = Directory::assets($query, $idDirectory);

        $assetsArray = array_map(function ($asset) {
            return $asset->toArray();
        }, $assets);

        print_r($assetsArray);

        //print_r($directory);
        //print_r($directory->toArray());
    } catch (\Stage\Exception\StoredProcedure $e) {
        echo $e->getMessage();
        echo $e->getCode();
        print_r($e->getObject());
    } catch (\Exception $e) {
        echo $e->getMessage();
    }
