<?php

    date_default_timezone_set('Europe/Lisbon');

    error_reporting(E_ALL);
    ini_set('display_errors', 1);

    require_once 'credentials.php';
    require_once dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR .'vendor/autoload.php';

    use Stage\Sps;
    use Stage\Account\User;
    use Stage\Stage;
    use Stage\Helper;
    use Stage\Account\Account;
    use Service\Connection;
    use Stage\Events\Event;
    use Stage\Account\Config\Config;
    use Stage\StoredProcedure\Manager as StoredProcedureManager;

    use Monolog\Logger;
    use Monolog\Handler\StreamHandler;

    $stageInstance = Stage::getInstance();

    $default = new Connection($credentials);
    $client = new Connection($clientCredentials);
    $leads = new Connection($leadsCredentials);
    $tasks = new Connection($tasksCredentials);
    $stageInstance->addConnection('default', $default);
    $stageInstance->addConnection('client', $client);
    $stageInstance->addConnection('leads', $leads);
    $stageInstance->addConnection('tasks', $tasks);

    // Change the connection name
    //$stageInstance->useConnection('client');

    // 3. Set the Stage stored procedures
    $stageInstance->setSps(Sps::load());

    // create a log channel
//    $log = new Logger('log');
//    $log->pushHandler(new StreamHandler(__DIR__ . DIRECTORY_SEPARATOR . 'log/log.log'));

    // add records to the log
//    $log->warning('Foo');
//    $log->error('Bar');
//    $log->info('some');

    // Set the StoredProcedure\Manager instance
    $spm = StoredProcedureManager::getInstance();
//    StoredProcedureManager::setLogger($log);

    // Set the Stored Procedure Manager
    $stageInstance->setStoredProcedureManager($spm);

    try {
        $idAccount = 3;
        $account = Account::find($idAccount);

        // Get a Stage instance
        $stageInstance->setAccount($account);

        // Get the account configurations ( Config instance is returned )
        $config = $account->getConfig();

        // Get a specific account configuration option
//        print_r($config->get(Config::ASSET_IMAGE));
//        print_r($config->get(Config::STORAGE_ASSETS));
//        print_r($config->get(Config::UPLOAD_MAX_FILESIZE));
//        print_r($config->get(Config::UPLOAD_ALLOWED_MIMETYPES));

//        print_r($config->get(Config::LOG_ENABLE));
//        print_r($config->get(Config::LOG_STORAGE));
//        print_r($config->get(Config::PUBLISH_VERSIONS));
    } catch (\Stage\Exception\StoredProcedure $e) {
        print_r(['error'=>
                    ['message'=> $e->getMessage(),
                        'type'=>'',
                        'object' => $e->getObject(),
                        'code'=> $e->getCode()]
        ]);
    } catch (Exception $e) {
        echo $e->getMessage();
    }
