<?php

    require_once '../bootstrap.php';

    use Stage\Account\Account;
    use Stage\Lead\Query;

    try {
        $idAccount = 3;
        $account = Account::find($idAccount, Account::ID);

        // Build query options
        $term = ""; // The term can be with operators like, title:aaa, firstname:bbb, lastname:ccc
        $tags = "111%Friday";          // Must be separated by %
        $filter = "tag";        // Filter is tag or hardtag

        $queryOptions = new stdClass();
        $queryOptions->term = htmlentities(trim($term), ENT_COMPAT, 'UTF-8');
        $queryOptions->filter = $filter;
        $queryOptions->tags = $tags;
        $queryOptions->from = 0;
        $queryOptions->to = -1;

        // Get all Lead
        $query = new Query($queryOptions);
        //print_r($query);
        

        $leads = $account->leads($query);

        print_r(array_map(function ($lead) {
            return $lead->toArray();
        }, $leads));

        //print_r($leads);
    } catch (Exception $e) {
        echo $e->getMessage();
    }
