<?php

    require_once '../bootstrap.php';

    use Stage\Post\Post as Post;
    use Stage\Post\Tag\Tag;
    use Stage\Stage as Stage;
    use Stage\Helper as Helper;
    use Service\Connection as Connection;
    use Stage\Asset\Asset;
    use Stage\Asset\Album\Album;

    $stageInstance = Stage::getInstance();
    $stageInstance->useConnection('client');

    // TODO
    // 1. Execute the SET_POSTS
    // 2. Para cada language executar SET_POSTS_L10N
    // 3. Apos executar a SET_POSTS_L10N executar para cada um a insercao das TAGS, BODY, PHOTOS

    // Data structure sent when creating or updating


    $l10n = ['id' => 12,
            'title' => '',
            'description' => '',
            'isoLanguage' => '',
            'beginDate' => '',
            'endDate' => '',
            'publishDate' => '',
            'metadata' => [
                'title' => '',
                'description' => '',
                'keywords' => '',
                'image' => [
                    'src' => '',
                    'title' => '',
                    'alt' => ''
                ]
            ],
           'body' => [
                [
                    'id'=>2,
                    'body' =>'HELLO'
                ],
               [
                   'id'=>3,
                   'body' =>'HELLO'
               ]
            ],
            'tags'=>[
                [
                    'id' => 2,
                    'name' => 'aaa',
                    'nameStripped' => 'name-stripped',
                    'public' => false,
                    'total' => 5
                ],
                [
                    'id' => 6,
                    'name' => 'bbb',
                    'nameStripped' => 'name-stripped',
                    'public' => false,
                    'total' => 5
                ]
            ]
    ];

    $req = [
        'id' => 12,
        'l10n' => [$l10n, $l10n, $l10n],
    ];

    //echo json_encode($req);


    $d1 = new DateTime("2012-07-08 11:14:15.638276");
    $d2 = new DateTime("2012-07-08 11:14:15.889342");

    $post = new Post();
    $l10n = new \Stage\Post\L10n\L10n();
    $l10en = new \Stage\Post\L10n\L10n();
    $metadata = new \Stage\Post\Metadata_todelete\Metadata();

    $l10n->setTitle("Post Title");                      // Optional
    $l10n->setDescription("Some Post Description");     // Optional
    $l10n->setIsoLanguage("pt");                        // Mandatory

    $l10n->setImage("IMAGE_PATH.png");                  // Optional

    $l10n->setBeginDate($d1);                           // Mandatory
    $l10n->setPublishDate($d1);                         // Mandatory
    $l10n->setEndDate($d2);                             // Mandatory

    $l10en->setTitle("Post Title");                     // Optional
    $l10en->setDescription("Some Post Description");    // Optional
    $l10en->setIsoLanguage("en");                       // Mandatory

    $l10en->setBeginDate($d1);                          // Mandatory
    $l10en->setPublishDate($d1);                        // Mandatory
    $l10en->setEndDate($d2);                            // Mandatory

    $metadata->setTitle("SOME METADATA TITLE");         // Optional
    $metadata->setDescription("Some meta description"); // Optional
    $metadata->setKeywords("Some Meta Keyworkds");      // Optional
    $metadata->setImage("IMAGE1252.png");               // Optional
    $metadata->setImageTitle("Some Meta Image title");  // Optional
    $metadata->setImageAlt("Some image alter text");    // Optional


    $l10n->addMetadata($metadata);
    //$l10en->addMetadata($metadata);

    $bodies = ["SOME HTML BODY 2", "SOME HTML BODY 2"]; // Optional
    foreach ($bodies as $b) {                              // Optional
        $body = new \Stage\Post\L10n\Body();            // Optional
        $body->setBody($b);                             // Optional
        $l10n->addBody($body);                          // Optional
    }

    $tags = [1,2,3,4];                                  // Optional
    foreach ($tags  as $tag) {
        $t = \Stage\Tag\Tag::find($tag);                // Optional
        $l10n->addTag($t);                              // Optional
    }

    // Add assets
    $asset1 = Asset::find(150);
    $asset2 = Asset::find(151);
    $l10n->addAsset($asset1);
    $l10n->addAsset($asset2);

    // Add albums
    $album1 = Album::find(1);
    $album2 = Album::find(2);
    $l10n->addAlbum($album1);
    $l10n->addAlbum($album2);


    // Add Post Languages as many as you want
    $post->addL10n($l10n);                              // Optional
    $post->addL10n($l10en);                             // Optional
    //$post->addL10n( clone $l10n );                    // Optional



    try {
        $post->save();
    } catch (Exception $e) {
    } catch (\Stage\Exception\StoredProcedure $e) {
    }

    print_r($post);

    echo json_encode($post->toArray());
