<?php

    require_once '../bootstrap.php';

    use Stage\Post\Tag\Tag;
    use Stage\Post\Post;
    use Stage\Stage as Stage;
    use Stage\Helper as Helper;
    use Stage\Post\L10n\BodyGroup;
    use Stage\Post\Metadata_todelete\Metadata;
    use Service\Connection as Connection;
    use Stage\Post\L10n\L10n;
    use Stage\Asset\Album\Album;
    use Stage\Asset\Asset;
    use Stage\Post\Author\Author;

    $l10n = ['id' => 12,
            'title' => '',
            'description' => '',
            'isoLanguage' => '',
            'beginDate' => '',
            'endDate' => '',
            'publishDate' => '',
            'metadata' => [
                'title' => '',
                'description' => '',
                'keywords' => '',
                'image' => '',
                'imageTitle' => '',
                'imageAlt' => ''

            ],
            'body' => [
                [
                    'id'=> 8503,
                    'body' =>'HELLO 2'
                ],
                [
                    'id'=> 8504,
                    'body' =>'HELLO 3'
                ]
            ],
            'tags'=>[
                [
                    'id' => 1,
                    'name' => 'aaa',
                    'nameStripped' => 'name-stripped',
                    'public' => false,
                    'total' => 5
                ],
                [
                    'id' => 1,
                    'name' => 'bbb',
                    'nameStripped' => 'name-stripped',
                    'public' => false,
                    'total' => 5
                ]
            ]
    ];

    $req = [
        'id' => 12,
        'l10n' => [$l10n, $l10n, $l10n]
    ];

    try {
        $idPost = 10;

        // Find the Post
        $post = Post::find($idPost);        // One Database call NOTE: Post is using the L10n::createInstance();
//        print_r($post);
//        die();
        $isoLanguagesToRemove = ['FR'];     // language that wasn't sent
        foreach ($isoLanguagesToRemove as $isoLanguage) {
            try {
                // Remove a L10n from Post and from Database
                $post->removeL10n($isoLanguage);
            } catch (Exception $e) {
                echo $e->getMessage();
            }
        }

        $isoLanguagesToSave = ['EN','HR','TO','HT','AA'];
        foreach ($isoLanguagesToSave as $isoLanguage) {
            try {
                // Verify if the L10n exists in the Post
                $l10n = L10n::find($post->getId(), $isoLanguage);
            } catch (Exception $e) {
                $l10n = new L10n();
                $l10n->setIsoLanguage(strtolower($isoLanguage));
            }

            $l10n->setTitle("Today2888 __");
            $l10n->setDescription("Today is Monday");
            $l10n->setImage("IMG_123.png");

            $d1 = new DateTime("2012-07-08 11:14:15.638276");
            $d2 = new DateTime("2012-07-08 11:14:15.889342");
            $d3 = new DateTime("2012-07-08 11:14:15.889342");

            $l10n->setBeginDate($d1);                          // Mandatory
            $l10n->setPublishDate($d2);                        // Mandatory
            $l10n->setEndDate($d3);                            // Mandatory

            // Get the Post Metadata and update it
            $metadata = $l10n->getMetadata() instanceof Metadata ? $l10n->getMetadata() : new Metadata();

            $metadata->setTitle("SOME META TITLE");
            $metadata->setDescription("Some meta description");
            $metadata->setKeywords("Some Meta Keyworkds");
            $metadata->setImage("IMAGE1252.png");
            $metadata->setImageTitle("Some Meta Image title___");
            $metadata->setImageAlt("Some image alter text___");

            $l10n->addMetadata($metadata);

            $bodyList = $l10n->getBody();

//            // Add the new Bodies
//            $bodies = ['HH','CC'];
//            foreach($bodies as $b)
//            {
//                $body = new Body();
//                $body->setBody($b);
//                $l10n->addBody($body);
//            }

//            // Add the new Tags
//            $tags = [1,3];                                  // $tags $albums=[] to delete tags
//            // Empty the L10n tags array
//            $l10n->discardTags();                             // Optional
//            foreach($tags  as $tag)
//            {
//                $t = Tag::find($tag);                         // Optional
//                $l10n->addTag($t);                            // Optional
//            }

//            $albums = [1,2];                                    // Pass $albums=[] to delete albums
//            $l10n->discardAlbums();
//            foreach($albums  as $id)
//            {
//                $a = Album::find($id);                       // Optional
//                $l10n->addAlbum($a);                         // Optional
//            }

//            $assets = [150,151];                            // Pass $assets=[] to delete assets
//            $l10n->discardAssets();
//            foreach($assets  as $id)
//            {
//                $a = Asset::find($id);                       // Optional
//                $l10n->addAsset($a);                         // Optional
//            }

//            $authors = [4,10];                            // Pass $authors=[] to delete assets
//            $l10n->discardAuthors();
//            foreach($authors  as $id)
//            {
//                $a = Author::find($id);                       // Optional
//                $l10n->addAuthor($a);                         // Optional
//            }
//            $post->addL10n($l10n);
        }

//            print_r($post->toArray());
//            print_r($post);

        // Save the post
        //$post->save();
        print_r($post->toArray());
    } catch (Exception $e) {
        echo $e->getMessage();
    }
