<?php

    require_once '../../bootstrap.php';

    use Stage\Video\Profile\Profile;
    use Stage\Video\Profile\Metadata\Metadata;

    $profile = new Profile();
    $profile->setTitle("miguel");
    $profile->setDescription("description");
    $profile->setImage("image");

    $metadata = new Metadata();
    $metadata->setTitle("metatitle");
    $metadata->setImageTitle("imageAlt");
    $profile->setMetadata($metadata);

    try {

        // First save the Profile on database
        $profile->save();

        // Tag tags
        $tag1 = \Stage\Video\Tag\Tag::find(1);
        $tag2 = \Stage\Video\Tag\Tag::find(2);
        $profile->tag($tag1);
        $profile->tag($tag1);

        // Body bodies
        $body1 = new \Stage\Video\Profile\Body\Body();
        $body1->setBody("Some body");
        $body2 = new \Stage\Video\Profile\Body\Body();
        $body2->setBody("Some body");

        $profile->body($body1);
        $profile->body($body2);

        // Asset assets
        $asset1 = \Stage\Asset\Asset::find(5);
        $asset2 = \Stage\Asset\Asset::find(6);

        $profile->asset($asset1);
        $profile->asset($asset2);

        // Album albums
        $album1 = \Stage\Asset\Album\Album::find(1);
        $album2 = \Stage\Asset\Album\Album::find(2);

        $profile->album($album1);
        $profile->album($album2);

        //print_r($profile);
        print_r($profile->toArray());
    } catch (Exception $e) {
        echo $e->getMessage();
    }
