create
    definer = skoiypp@`%` function FN_ENCODE_HTML_ENTITIES(X VARCHAR(255)) returns varchar(255) CHARSET utf8
    deterministic
BEGIN

 DECLARE TextString VARCHAR(255) ; 
 DECLARE word VARCHAR(255);
DECLARE deword VARCHAR(255);
 
    SET TextString = X ; 

    SET word = '&quot;';
    SET deword = '"';

    #quotation mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&apos;';
    SET deword = '"';

    #apostrophe  
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&amp;';
    SET deword = '&';

    #ampersand 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&lt;';
    SET deword = '<';

    #less-than 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&gt;';
    SET deword = '>';

    #greater-than 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 


    SET word = '&nbsp;';
    SET deword = ' ';

    #non-breaking space 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&iexcl;';
    SET deword = '¡';

    #inverted exclamation mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&cent;';
    SET deword = '¢';

    #cent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 


    SET word = '&pound;';
    SET deword = '£';

    #pound 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&curren;';
    SET deword = '¤';

    #currency 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 


    SET word = '&yen;';
    SET deword = '¥';

    #yen 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 


    SET word = '&brvbar;';
    SET deword = '¦';

    #broken vertical bar 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&sect;';
    SET deword = '§';

    #section 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&uml;';
    SET deword = '¨';

    #spacing diaeresis 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&copy;';
    SET deword = '©';

    #copyright 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ordf;';
    SET deword = 'ª';

    #feminine ordinal indicator 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&laquo;';
    SET deword = '«';

    #angle quotation mark (left) 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&not;';
    SET deword = '¬';

    #negation 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 
    
    SET word = '&shy;';
    SET deword = '­';

    #soft hyphen 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&reg;';
    SET deword = '®';

    #registered trademark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&macr;';
    SET deword = '¯';

    #spacing macron 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 


    SET word = '&deg;';
    SET deword = '°';

    #degree 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&plusmn;';
    SET deword = '±';

    #plus-or-minus  
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&sup2;';
    SET deword = '²';

    #superscript 2 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&sup3;';
    SET deword = '³';

    #superscript 3 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&acute;';
    SET deword = '´';

    #spacing acute 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&micro;';
    SET deword = 'µ';

    #micro 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&para;';
    SET deword = '¶';

    #paragraph 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&middot;';
    SET deword = '·';

    #middle dot 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&cedil;';
    SET deword = '¸';

    #spacing cedilla 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&sup1;';
    SET deword = '¹';

    #superscript 1 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ordm;';
    SET deword = 'º';

    #masculine ordinal indicator 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&raquo;';
    SET deword = '»';

    #angle quotation mark (right) 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&frac14;';
    SET deword = '¼';

    #fraction 1/4 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 





    SET word = '&frac12;';
    SET deword = '½';

    #fraction 1/2 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    
    SET word = '&frac34;';
    SET deword = '¾';

    #fraction 3/4 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&iquest;';
    SET deword = '¿';

    #inverted question mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&times;';
    SET deword = '×';

    

    #multiplication 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&divide;';
    SET deword = '÷';

    #division 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Agrave;';
    SET deword = 'À';

    #capital a, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Aacute;';
    SET deword = 'Á';

    #capital a, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Acirc;';
    SET deword = 'Â';

    #capital a, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Atilde;';
    SET deword = 'Ã';

    #capital a, tilde 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Auml;';
    SET deword = 'Ä';

    #capital a, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Aring;';
    SET deword = 'Å';

    #capital a, ring 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&AElig;';
    SET deword = 'Æ';

    #capital ae 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ccedil;';
    SET deword = 'Ç';

    #capital c, cedilla 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Egrave;';
    SET deword = 'È';

    #capital e, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Eacute;';
    SET deword = 'É';

    #capital e, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ecirc;';
    SET deword = 'Ê';

    #capital e, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Euml;';
    SET deword = 'Ë';

    #capital e, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Igrave;';
    SET deword = 'Ì';

    #capital i, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Iacute;';
    SET deword = 'Í';

    #capital i, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Icirc;';
    SET deword = 'Î';

    #capital i, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Iuml;';
    SET deword = 'Ï';

    #capital i, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ETH;';
    SET deword = 'Ð';

    #capital eth, Icelandic 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ntilde;';
    SET deword = 'Ñ';

    #capital n, tilde 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ograve;';
    SET deword = 'Ò';

    #capital o, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 


    SET word = '&Oacute;';
    SET deword = 'Ó';

    #capital o, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ocirc;';
    SET deword = 'Ô';

    #capital o, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Otilde;';
    SET deword = 'Õ';

    #capital o, tilde 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ouml;';
    SET deword = 'Ö';

    #capital o, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Oslash;';
    SET deword = 'Ø';

    #capital o, slash 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ugrave;';
    SET deword = 'Ù';

    #capital u, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Uacute;';
    SET deword = 'Ú';

    #capital u, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Ucirc;';
    SET deword = 'Û';

    #capital u, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Uuml;';
    SET deword = 'Ü';

    #capital u, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&Yacute;';
    SET deword = 'Ý';

    #capital y, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&THORN;';
    SET deword = 'Þ';

    #capital THORN, Icelandic 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&szlig;';
    SET deword = 'ß';

    #small sharp s, German 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&agrave;';
    SET deword = 'à';

    #small a, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&aacute;';
    SET deword = 'á';

    #small a, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&acirc;';
    SET deword = 'â';

    #small a, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&atilde;';
    SET deword = 'ã';

    #small a, tilde 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&auml;';
    SET deword = 'ä';

    #small a, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&aring;';
    SET deword = 'å';

    #small a, ring 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&aelig;';
    SET deword = 'æ';

    #small ae 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ccedil;';
    SET deword = 'ç';

    #small c, cedilla 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&egrave;';
    SET deword = 'è';

    #small e, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&eacute;';
    SET deword = 'é';

    #small e, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ecirc;';
    SET deword = 'ê';

    #small e, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&euml;';
    SET deword = 'ë';

    #small e, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&igrave;';
    SET deword = 'ì';

    #small i, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&iacute;';
    SET deword = 'í';

    #small i, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&icirc;';
    SET deword = 'î';

    #small i, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&iuml;';
    SET deword = 'ï';

    #small i, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&eth;';
    SET deword = 'ð';

    #small eth, Icelandic 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ntilde;';
    SET deword = 'ñ';

    #small n, tilde 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ograve;';
    SET deword = 'ò';

    #small o, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&oacute;';
    SET deword = 'ó';

    #small o, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ocirc;';
    SET deword = 'ô';

    #small o, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 
    
    SET word = '&otilde;';
    SET deword = 'õ';

    #small o, tilde 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ouml;';
    SET deword = 'ö';

    #small o, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&oslash;';
    SET deword = 'ø';

    #small o, slash 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ugrave;';
    SET deword = 'ù';

    #small u, grave accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&uacute;';
    SET deword = 'ú';

    #small u, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&ucirc;';
    SET deword = 'û';

    #small u, circumflex accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&uuml;';
    SET deword = 'ü';

    #small u, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&yacute;';
    SET deword = 'ý';

    #small y, acute accent 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&thorn;';
    SET deword = 'þ';

    #small thorn, Icelandic 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    SET word = '&yuml;';
    SET deword = 'ÿ';

    #small y, umlaut mark 
    IF INSTR( X , deword ) 
    THEN 
        SET TextString = REPLACE(TextString, deword,word);
    END IF ; 

    RETURN TextString ; 


END;

