create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_VERSIONS(IN _id_video INT, IN _file_name VARCHAR(192),
                                                          IN _extension VARCHAR(8), IN _width INT(10),
                                                          IN _height INT(10), IN _version VARCHAR(192),
                                                          IN _version_type VARCHAR(192), IN _size BIGINT,
                                                          IN _bitrate BIGINT, IN _audio_bitrate BIGINT,
                                                          IN _default_version INT(10), IN _id_storage int(10),
                                                          IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _is_default TINYINT(1);

DECLARE t_versions INT(10);
DECLARE t_id_video INT(10);
DECLARE t_name VARCHAR(255);
DECLARE t_sec FLOAT(10,2);
DECLARE t_date datetime;
DECLARE t_stream VARCHAR(255);


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;
SET _is_default = 0;

START TRANSACTION;

SELECT count(1) into t_versions FROM video_versions WHERE id_video = _id_video;

IF NOT EXISTS (SELECT id_video FROM video_versions WHERE id_video = _id_video AND version = _version AND version_type = _version_type)
THEN

IF(_version = _default_version)
THEN
	SET _is_default = 1;
END IF;

	INSERT into video_versions(id_video,id_storage,id_cdn,filename,extension,width,height,version,version_type,size,bitrate,audio_bitrate,is_default,register_date) VALUES(_id_video,_id_storage,_id_cdn,_file_name,_extension,_width,_height,_version,_version_type,_size,_bitrate,_audio_bitrate,_is_default,now());
	SET p_last_id = last_insert_id();
	SELECT id_version,id_video,id_storage,id_cdn,filename,extension,width,height,version,version_type,size,state,bitrate,audio_bitrate,is_default FROM video_versions WHERE id_version = p_last_id;
    
ELSE
	UPDATE video_versions SET id_storage = _id_storage, id_cdn = _id_cdn, update_date = now() WHERE id_video = _id_video AND version = _version AND version_type = _version_type;
	SELECT -2 as return_code;
END IF;


IF(t_versions = 0)
THEN

	SELECT id_video,name,seconds,CONVERT(SUBSTRING_INDEX(name,'|',1),datetime),REPLACE(SUBSTRING_INDEX(SUBSTRING_INDEX(name,'|',-1),'_',1),'.mp4','') 
 	into t_id_video,t_name,t_sec,t_date,t_stream 
	FROM videos WHERE deleted = 0 AND CONVERT(SUBSTRING_INDEX(name,'|',1),datetime) is not null AND id_video = _id_video;


	
	IF(t_id_video > 0)
	THEN
    
		SET t_date = DATE_ADD(t_date,INTERVAL +time_to_sec(TIMEDIFF(NOW(), UTC_TIMESTAMP)) SECOND);
		SET @_idLive = (SELECT id_live FROM Accounts.accounts_live_server_settings WHERE stream = t_stream );
		SET @_idComposed = (SELECT id_composed FROM video_composed WHERE id_live = @_idLive AND publish_date BETWEEN DATE_ADD(t_date,INTERVAL -5 MINUTE) AND DATE_ADD(t_date,INTERVAL 5 MINUTE) LIMIT 0,1) ;
		SET @_idPlaylist = (SELECT id_playlist FROM video_composed_playlists_related WHERE id_composed = @_idComposed LIMIT 0,1);
        
		INSERT into video_sync_live_log(id_live,id_video,id_composed,id_playlist,video_date,register_date) VALUES (@_idLive,_id_video,@_idComposed,@_idPlaylist,t_date,now());
        
		UPDATE video_versions vv SET import_type = 1 WHERE vv.id_video in 
		(SELECT v.id_video FROM videos v WHERE v.id_video = vv.id_video AND v.seconds > 1200 AND v.id_video = t_id_video AND
		vv.update_date = '0000-00-00 00:00:00' AND v.deleted = 0);
        
	END IF;    
    

END IF;    


	
    IF(SELECT count(1) FROM video_versions WHERE id_video = _id_video AND import_type = 0)
	THEN
		DELETE FROM video_versions WHERE id_video = _id_video AND import_type = 1;
	END IF;
	

COMMIT;

END;

