<?php namespace Stage\Account\Settings;

use PDO;
use Exception;
use Stage\Stage as Stage;
use Stage\Account\Account as Account;

class Couch
{

    /**
     * @var
     */
    private static $instance;

    /**
     * @var
     */
    private $host;

    /**
     * @var
     */
    private $port;

    private function __construct()
    {
    }

    /**
     * getInstance
     *
     * @return Couch
     */
    public static function getInstance()
    {
        if (!self::$instance) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function getHost()
    {
        return $this->host;
    }

    public function getPort()
    {
        return $this->port;
    }

    public function setHost($host)
    {
        $this->host = $host;
    }

    public function setPort($port)
    {
        $this->port = $port;
    }

    /**
     * getSettings
     *
     * @param $idAccount
     */
    public function getSettings(Account $account)
    {
        $idAccount = $account->getId();
        $parameters = [[$idAccount, PDO::PARAM_INT]];

        // Make a request to Database
        try {
            $name = "ACCOUNT_NOSQL_ACCESS_CONFIG";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);

            if (sizeof($data) > 0) {
                $accInstance = self::createInstance($data[0]);
                return $accInstance;
            } else {
                throw new Exception("The database for the account $idAccount is not created");
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * createInstance
     *
     * @param $data
     * @return Couch
     */
    public static function createInstance($data)
    {
        $accInstance = new self();
        $accInstance->setHost($data['bd_host']);
        $accInstance->setPort($data['bd_port']);

        return $accInstance;
    }
}
