<?php namespace Stage\Ad\Video\Transcode\Preview;

use PDO;
use Exception;
use Stage\Stage;
use Stage\Video\Transcode\Job;

class Transcode
{

    /**
     * @var
     */
    private $idAccount;

    /**
     * @var
     */
    private $accountToken;

    /**
     * @var
     */
    private $idVideo;

    /**
     * @var
     */
    private $inputPath;

    /**
     * @var
     */
    private $outputPath;

    /**
     * @var
     */
    private $filename;

    /**
     * @var
     */
    private $source;

    /**
     * @var
     */
    private $with;

    /**
     * @var
     */
    private $height;

    /**
     * @var
     */
    private $seconds;

    /**
     * @var
     */
    private $aspecRatio;

    /**
     * @var
     */
    private $videoCodec;

    /**
     * @var
     */
    private $audioCodec;

    /**
     * @var
     */
    private $audioRate;

    /**
     * @var
     */
    private $videoRate;

    /**
     * @var
     */
    private $version;

    /**
     * @var
     */
    private $h264;

    /**
     * @var
     */
    private $ogg;

    /**
     * @var
     */
    private $webVersion;

    /**
     * @var
     */
    private $webm;

    /**
     * @var
     */
    private $mobileVersion;

    /**
     * @var integer
     */
    private $idStorage = 0;

    /**
     * @var integer
     */
    private $idCdn = 0;

    public function getIdAccount()
    {
        return $this->idAccount;
    }

    public function getAccountToken()
    {
        return $this->accountToken;
    }

    public function getIdVideo()
    {
        return $this->idVideo;
    }

    public function getInputPath()
    {
        return $this->inputPath;
    }

    public function getOutputPath()
    {
        return $this->outputPath;
    }

    public function getFilename()
    {
        return $this->filename;
    }

    public function getSource()
    {
        return $this->source;
    }

    public function getWith()
    {
        return $this->with;
    }

    public function getHeight()
    {
        return $this->height;
    }

    public function getSeconds()
    {
        return $this->seconds;
    }

    public function getAspectRatio()
    {
        return $this->aspecRatio;
    }

    public function getVideoCodec()
    {
        return $this->videoCodec;
    }

    public function getAudioCodec()
    {
        return $this->audioCodec;
    }

    public function getAudioRate()
    {
        return $this->audioRate;
    }

    public function getVideoRate()
    {
        return $this->videoRate;
    }

    public function getVersion()
    {
        return $this->version;
    }

    public function getIdStorage()
    {
        return $this->idStorage;
    }

    public function getIdCdn()
    {
        return $this->idCdn;
    }

    public function getH264()
    {
        return $this->h264;
    }

    public function getWebm()
    {
        return $this->webm;
    }

    public function getOgg()
    {
        return $this->ogg;
    }

    public function getWebVersion()
    {
        return $this->webVersion;
    }

    public function toMobileVersion()
    {
        return $this->mobileVersion;
    }

    public function setIdAccount($idAccount)
    {
        return $this->idAccount = $idAccount;
    }

    public function setAccountToken($accountToken)
    {
        return $this->accountToken = $accountToken;
    }

    public function setIdVideo($idVideo)
    {
        return $this->idVideo = $idVideo;
    }

    public function setInputPath($inputPath)
    {
        return $this->inputPath = $inputPath;
    }

    public function setOutputPath($outputPath)
    {
        return $this->outputPath = $outputPath;
    }

    public function setFilename($filename)
    {
        return $this->filename = $filename;
    }

    public function setSource($source)
    {
        return $this->source = $source;
    }

    public function setWith($with)
    {
        return $this->with = $with;
    }

    public function setHeight($height)
    {
        return $this->height = $height;
    }

    public function setSeconds($seconds)
    {
        return $this->seconds = $seconds;
    }

    public function setAspecRatio($aspecRatio)
    {
        return $this->aspecRatio = $aspecRatio;
    }

    public function setVideoCodec($videoCodec)
    {
        return $this->videoCodec = $videoCodec;
    }

    public function setAudioCodec($audioCodec)
    {
        return $this->audioCodec = $audioCodec;
    }

    public function setAudioRate($audioRate)
    {
        return $this->audioRate = $audioRate;
    }

    public function setVideoRate($videoRate)
    {
        return $this->videoRate = $videoRate;
    }

    public function setVersion($version)
    {
        return $this->version = $version;
    }

    public function setToH264($h264)
    {
        return $this->h264 = $h264;
    }

    public function setToOgg($ogg)
    {
        return $this->ogg = $ogg;
    }

    public function setToWebm($webm)
    {
        return $this->webm = $webm;
    }

    public function setToWebVersion($webVersion)
    {
        return $this->webVersion = $webVersion;
    }

    public function setToMobileVersion($mobileVersion)
    {
        return $this->mobileVersion = $mobileVersion;
    }

    public function setIdStorage($id)
    {
        return $this->idStorage = $id;
    }

    public function setIdCdn($id)
    {
        $this->idCdn = $id;
    }

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id','account','code','password','uploadMaxSize','uploadTypes','shared','endDate', 'idStorage', 'idCdn');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    /**
     * save
     *
     * @return $this
     * @throws Exception
     */
    public function save()
    {
        try {
            $name = "ADS_VIDEO_TRANSCODING";
            $method = "SET";
            $parameters = [[$this->getIdAccount(), PDO::PARAM_INT],
                           [$this->getAccountToken(), PDO::PARAM_STR],
                           [$this->getIdVideo(), PDO::PARAM_INT],
                           [$this->getInputPath(), PDO::PARAM_STR],
                           [$this->getOutputPath(), PDO::PARAM_STR],
                           [$this->getFilename(), PDO::PARAM_STR],
                           [$this->getSource(), PDO::PARAM_STR],
                           [$this->getWith(), PDO::PARAM_INT],
                           [$this->getHeight(), PDO::PARAM_INT],
                           [$this->getSeconds(), PDO::PARAM_INT],
                           [$this->getAspectRatio(), PDO::PARAM_STR],
                           [$this->getAudioCodec(), PDO::PARAM_STR],
                           [$this->getAudioRate(), PDO::PARAM_INT],
                           [$this->getVideoRate(), PDO::PARAM_INT],
                           [$this->getVersion(), PDO::PARAM_INT],
                           [$this->getH264(), PDO::PARAM_INT],
                           [$this->getOgg(), PDO::PARAM_INT],
                           [$this->getWebm(), PDO::PARAM_INT],
                           [$this->getWebVersion(), PDO::PARAM_INT],
                           [$this->toMobileVersion(), PDO::PARAM_INT],
                           [$this->getIdStorage(), PDO::PARAM_INT],
                           [$this->getIdCdn(), PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);

            if (!sizeof($data)) {
                throw new Exception("Error saving Transcode.");
            } else {
                return $data;
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * next
     *
     * Get the next transcode video
     *
     * @param int $field
     * @return mixed|Job
     * @throws Exception
     */
    public static function next($field = 0, $machine = "")
    {
        try {
            $name = "ADS_TO_TRANSCODE";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                           [$machine, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);

            return isset($data[0]) && isset($data[0]['return_code']) ? [] : Job::createInstance($data[0]);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * done
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function done($idQueue, $field = 1, $end = false)
    {
        try {
            $name = $end ? "" : "ADS_VIDEO_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * retry
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function retry($idQueue, $field = 1, $end = false)
    {
        try {
            $name = $end ? "" : "ADS_VIDEO_NOT_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * softDelete
     *
     * @param $idAccount
     * @param $idVideo
     * @param bool $deleted
     * @return array
     * @throws Exception
     */
    public static function softDelete($idAccount, $idVideo, $deleted = true)
    {
        try {
            $name = "ADS_VIDEO_TRANSCODING_DELETED";
            $method = "SET";
            $parameters = [[$idAccount, PDO::PARAM_INT],
                           [$idVideo, PDO::PARAM_INT],
                           [$deleted, PDO::PARAM_BOOL]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idAccount
     * @param $idVideo
     * @return array
     * @throws Exception
     */
    public static function delete($idAccount, $idVideo)
    {
        try {
            $name = "ADS_VIDEO_TRANSCODING";
            $method = "DEL";
            $parameters = [[$idAccount, PDO::PARAM_INT],
                [$idVideo, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * query
     *
     * @param $idAccount
     * @param $idVideo
     * @param bool $deleted
     * @return mixed|Job
     * @throws Exception
     */
    public static function query(Query $q)
    {
        try {
            $name = "TRANSCODER_ADS_VIDEOS";
            $method = "GET";
            $field          = $q->by;
            $sndField       = $q->sndBy;
            $trdField       = $q->trdBy;
            $term           = $q->term;
            $filter         = $q->filter;
            $sndFilter      = $q->sndFilter;
            $trdFilter      = $q->trdFilter;
            $limit_a        = $q->from;
            $limit_b        = $q->to;
            $order          = $q->order;
            $orderBy        = $q->orderBy;

            $parameters = [[$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_INT],
                [$sndFilter, PDO::PARAM_INT],
                [$trdFilter, PDO::PARAM_INT],
                [$limit_a, PDO::PARAM_INT],
                [$limit_b, PDO::PARAM_INT],
                [$order, PDO::PARAM_INT],
                [$orderBy, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);

            return array_map(function ($video) {
                return Job::createInstance($video);
            }, $data);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * queryCount
     *
     * Count videos by query
     * @return []
     * @throws Exception
     */
    public static function queryCount(Query $q = null, $idDirectory = 0)
    {
        $field          = $q->by;
        $sndField       = $q->sndBy;
        $trdField       = $q->trdBy;
        $term           = $q->term;
        $filter         = $q->filter;
        $sndFilter      = $q->sndFilter;
        $trdFilter      = $q->trdFilter;

        try {

            $parameters = [ [$field, PDO::PARAM_INT],
                [$sndField, PDO::PARAM_INT],
                [$trdField, PDO::PARAM_INT],
                [$term, PDO::PARAM_STR],
                [$filter, PDO::PARAM_STR],
                [$sndFilter, PDO::PARAM_STR],
                [$trdFilter, PDO::PARAM_STR]];

            $name = "TRANSCODER_ADS_VIDEOS_COUNT";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return $data[0]['total'];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $attribute == "account" ? $this->getAccount()->toArray() : $this->$attribute;
        }

        return $arr;
    }

    public function __toString()
    {
        $p = array_map(function ($var) {
            return "'" . $var . "'";
        }, get_object_vars($this));

        return implode(',', $p);
    }
}
