<?php namespace Stage\Archive\Clip;

use Exception;
use Stage\Archive\Directory as RootDirectory;
use Stage\Archive\Clip\Query as ClipQuery;

class Directory extends RootDirectory
{
    public static function find($id, $toLevel = 10000, $name = '')
    {
        try {
            return parent::find($id, $toLevel, 'ARCHIVE_CLIP_DIRECTORY');
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function build($name = 'ARCHIVE_CLIP_DIRECTORIES')
    {
        try {
            return parent::build($name);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function all($raw = false, $name = '')
    {
        try {
            return parent::all($raw, 'ARCHIVE_CLIP_DIRECTORIES');
        } catch (Exception $e) {
            throw $e;
        }
    }


    public static function delete($idDirectory, $softDelete = true, $deleted = true, $name = '')
    {
        try {
            $name = $softDelete ? 'ARCHIVE_CLIPS_DIRECTORY_DELETED' : 'CLIP_DIRECTORY';
            return parent::delete($idDirectory, $softDelete, $deleted, $name);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function markedToDelete($name = '')
    {
        try {
            $name = 'ARCHIVE_CLIP_DIRECTORIES_DELETED';
            return parent::markedToDelete($name);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function appendTo(RootDirectory $targetDirectory = null, $name = 'ARCHIVE_CLIPS_DIRECTORIES')
    {
        try {
            return parent::appendTo($targetDirectory, $name);
        } catch (Exception $e) {
            throw $e;
        }
    }
}
