<?php namespace Stage\Archive\Clip\Transcode\Preview;

use PDO;
use Exception;
use Stage\Stage;

class Transcode
{

    /**
     * @var
     */
    private $idAccount;

    /**
     * @var
     */
    private $accountToken;

    /**
     * @var
     */
    private $idClip;

    /**
     * @var
     */
    private $inputPath;

    /**
     * @var
     */
    private $outputPath;

    /**
     * @var
     */
    private $filename;

    /**
     * @var
     */
    private $source;

    /**
     * @var
     */
    private $with;

    /**
     * @var
     */
    private $height;

    /**
     * @var
     */
    private $seconds;

    /**
     * @var
     */
    private $aspecRatio;

    /**
     * @var
     */
    private $videoCodec;

    /**
     * @var
     */
    private $audioCodec;

    /**
     * @var
     */
    private $audioRate;

    /**
     * @var
     */
    private $videoRate;

    /**
     * @var
     */
    private $mobileVersion;

    /**
     * @var
     */
    private $registerDate;

    public function getIdAccount()
    {
        return $this->idAccount;
    }

    public function getAccountToken()
    {
        return $this->accountToken;
    }

    public function getIdClip()
    {
        return $this->idClip;
    }

    public function getInputPath()
    {
        return $this->inputPath;
    }

    public function getOutputPath()
    {
        return $this->outputPath;
    }

    public function getFilename()
    {
        return $this->filename;
    }

    public function getSource()
    {
        return $this->source;
    }

    public function getWith()
    {
        return $this->with;
    }

    public function getHeight()
    {
        return $this->height;
    }

    public function getSeconds()
    {
        return $this->seconds;
    }

    public function getAspectRatio()
    {
        return $this->aspecRatio;
    }

    public function getVideoCodec()
    {
        return $this->videoCodec;
    }

    public function getAudioCodec()
    {
        return $this->audioCodec;
    }

    public function getAudioRate()
    {
        return $this->audioRate;
    }

    public function getVideoRate()
    {
        return $this->videoRate;
    }

    public function toMobileVersion()
    {
        return $this->mobileVersion;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function setIdAccount($idAccount)
    {
        return $this->idAccount = $idAccount;
    }

    public function setAccountToken($accountToken)
    {
        return $this->accountToken = $accountToken;
    }

    public function setIdClip($idClip)
    {
        return $this->idClip = $idClip;
    }

    public function setInputPath($inputPath)
    {
        return $this->inputPath = $inputPath;
    }

    public function setOutputPath($outputPath)
    {
        return $this->outputPath = $outputPath;
    }

    public function setFilename($filename)
    {
        return $this->filename = $filename;
    }

    public function setSource($source)
    {
        return $this->source = $source;
    }

    public function setWith($with)
    {
        return $this->with = $with;
    }

    public function setHeight($height)
    {
        return $this->height = $height;
    }

    public function setSeconds($seconds)
    {
        return $this->seconds = $seconds;
    }

    public function setAspecRatio($aspecRatio)
    {
        return $this->aspecRatio = $aspecRatio;
    }

    public function setVideoCodec($videoCodec)
    {
        return $this->videoCodec = $videoCodec;
    }

    public function setAudioCodec($audioCodec)
    {
        return $this->audioCodec = $audioCodec;
    }

    public function setAudioRate($audioRate)
    {
        return $this->audioRate = $audioRate;
    }

    public function setVideoRate($videoRate)
    {
        return $this->videoRate = $videoRate;
    }

    public function setRegisterDate($registerDate)
    {
        return $this->registerDate = $registerDate;
    }

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id','account','code','password','uploadMaxSize','uploadTypes','shared','endDate');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    /**
     * save
     *
     * @return $this
     * @throws Exception
     */
    public function save()
    {
        try {
            $name = "ARCHIVE_CLIP_PREVIEW";
            $method = "SET";
            $parameters = [[$this->getIdAccount(), PDO::PARAM_INT],
                           [$this->getAccountToken(), PDO::PARAM_STR],
                           [$this->getIdClip(), PDO::PARAM_INT],
                           [$this->getInputPath(), PDO::PARAM_STR],
                           [$this->getOutputPath(), PDO::PARAM_STR],
                           [$this->getFilename(), PDO::PARAM_STR],
                           [$this->getSource(), PDO::PARAM_STR],
                           [$this->getWith(), PDO::PARAM_INT],
                           [$this->getHeight(), PDO::PARAM_INT],
                           [$this->getSeconds(), PDO::PARAM_INT],
                           [$this->getAspectRatio(), PDO::PARAM_STR],
                           [$this->getVideoCodec(), PDO::PARAM_STR],
                           [$this->getAudioCodec(), PDO::PARAM_STR],
                           [$this->getAudioRate(), PDO::PARAM_INT],
                           [$this->getVideoRate(), PDO::PARAM_INT],
                           [$this->getRegisterDate(), PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);

            if (!sizeof($data)) {
                throw new Exception("Error saving Transcode.");
            } else {
                return $data;
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * next
     *
     * Get the next transcode video
     *
     * @param int $field
     * @return mixed|Job
     * @throws Exception
     */
    public static function next($field = 0, $machine = "")
    {
        try {
            $name = "ARCHIVE_CLIP_PREVIEW_TO_PROCESS";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                           [$machine, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);

            return isset($data[0]) && isset($data[0]['return_code']) ? [] : Job::createInstance($data[0]);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * done
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function done($idQueue, $field = 1, $end = false)
    {
        try {
            $name = $end ? "ARCHIVE_END_UPDATE_CLIP_PREVIEW_PROCESSED" : "ARCHIVE_CLIP_PREVIEW_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * retry
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function retry($idQueue, $field = 1, $end = false)
    {
        try {
            $name = $end ? "ARCHIVE_END_UPDATE_CLIP_PREVIEW_NOT_PROCESSED" : "ARCHIVE_CLIP_PREVIEW_NOT_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * softDelete
     *
     * @param $idAccount
     * @param $idVideo
     * @param bool $deleted
     * @return array
     * @throws Exception
     */
    public static function softDelete($idAccount, $idClip, $deleted = true)
    {
        try {
            $name = "ARCHIVE_CLIP_PREVIEW_DELETED";
            $method = "SET";
            $parameters = [[$idAccount, PDO::PARAM_INT],
                            [$idClip, PDO::PARAM_INT],
                            [$deleted, PDO::PARAM_BOOL]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idAccount
     * @param $idVideo
     * @return array
     * @throws Exception
     */
    public static function delete($idAccount, $idClip)
    {
        try {
            $name = "ARCHIVE_CLIP_PREVIEW";
            $method = "DEL";
            $parameters = [[$idAccount, PDO::PARAM_INT],
                           [$idClip, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function d1($idQueue, $field = 1)
    {
        // TODO
        try {
            $name = "ARCHIVE_END_UPDATE_CLIP_PREVIEW";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /*public static function d2($idQueue, $field = 1)
    {
        // TODO
        try {

            $name = "ARCHIVE_END_UPDATE_CLIP_PREVIEW_NOT_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;

        } catch(Exception $e){
            throw $e;
        }
    }*/

    /*public static function d3($idQueue, $field = 1)
    {
        // TODO
        try {

            $name = "ARCHIVE_END_UPDATE_CLIP_PREVIEW_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;

        } catch(Exception $e){
            throw $e;
        }
    }*/

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $attribute == "account" ? $this->getAccount()->toArray() : $this->$attribute;
        }

        return $arr;
    }

    public function __toString()
    {
        $p = array_map(function ($var) {
            return "'" . $var . "'";
        }, get_object_vars($this));

        return implode(',', $p);
    }
}
