<?php namespace Stage\Archive\Download;

use PDO;
use DateTime;
use Exception;
use Stage\Stage;
use Stage\Helper;

class Download
{
    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $type = "";

    /**
     * @var
     */
    private $name = "";

    /**
     * @var
     */
    private $code = "";

    /**
     * @var
     */
    private $password = "";

    /**
     * @var
     */
    private $endDate = "";

    /**
     * @var
     */
    private $active = false;

    /**
     * @var
     */
    private $term = "";

    /**
     * @var
     */
    private $directoryId;

    /**
     * @var
     */
    private $tag = "";

    /**
     * @var
     */
    private $systemTag = "";

    /**
     * @var
     */
    private $systemTagValue = "";

    /**
     * @var
     */
    private $room = "";

    /**
     * @var
     */
    private $idUser;

    /**
     * @var
     */
    private $orderBy;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'type','name','code','password','endDate','active', 'term', 'directoryId' ,'tag','systemTag','systemTagValue','room','idUser','orderBy');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getType()
    {
        return $this->type;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getCode()
    {
        return $this->code;
    }

    public function getPassword()
    {
        return $this->password;
    }

    public function getEndDate()
    {
        return $this->endDate;
    }

    public function getActive()
    {
        return $this->active;
    }

    public function getTerm()
    {
        return $this->term;
    }

    public function getIdDirectory()
    {
        return $this->directoryId;
    }

    public function getTag()
    {
        return $this->tag;
    }

    public function getSystemTag()
    {
        return $this->systemTag;
    }

    public function getSystemTagValue()
    {
        return $this->systemTagValue;
    }

    public function getRoom()
    {
        return $this->room;
    }

    public function getIdUser()
    {
        return $this->idUser;
    }

    public function getOrderBy()
    {
        return $this->orderBy;
    }

    private function setId($id)
    {
        $this->id = (int) $id;
    }

    public function setType($type)
    {
        $this->type = $type;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setCode($code)
    {
        $this->code = $code;
    }

    public function setPassword($password)
    {
        $this->password = $password;
    }

    public function setEndDate($endDate)
    {
        $this->endDate = $endDate;
    }

    public function setRegisterDate($registerDate)
    {
        $this->registerDate = $registerDate;
    }

    public function setActive($active)
    {
        $this->active = $active;
    }

    public function setTerm($term)
    {
        $this->term = $term;
    }

    public function setDirectoryId($id)
    {
        $this->directoryId = (int) $id;
    }

    public function setTag($tag)
    {
        $this->tag = $tag;
    }

    public function setSystemTag($systemTag)
    {
        $this->systemTag = $systemTag;
    }

    public function setSystemTagValue($systemTagValue)
    {
        $this->systemTagValue = $systemTagValue;
    }

    public function setRoom($room)
    {
        $this->room = $room;
    }

    public function setIdUser($idUser)
    {
        $this->idUser = $idUser;
    }

    public function setOrderBy($orderBy)
    {
        $this->orderBy = $orderBy;
    }

    /**
     * @return array
     */
    public static function sizeof()
    {
        $name = "ARCHIVE_SHARE_AND_DOWNLOADS_NUM";
        $method = "GET";
        $parameters = [];
        $data = Stage::esp($parameters, $name, $method);
        return $data[0]['total'];
    }

    /**
     * all
     *
     * @return $this
     * @throws Exception
     */
    public static function all()
    {
        try {
            $query = new Query();
            $query->by = Query::ALL;
            $query->from = 0;
            $query->to = -1;

            return self::query($query);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * query
     *
     * Search Downloads by Query query
     *
     * @return mixed
     * @throws Exception
     */
    public static function query(Query $q)
    {
        $field = $q->by;
        $query = $q->term;
        $limit_a = $q->from;
        $limit_b = $q->to;
        $filter = $q->filter;

        try {
            $method = "GET";
            $parameters = [ [$field, PDO::PARAM_STR],
                            [$query, PDO::PARAM_INT],
                            [$filter,PDO::PARAM_STR],
                            [$limit_a, PDO::PARAM_INT],
                            [$limit_b, PDO::PARAM_INT]];

            $name = "ARCHIVE_SHARE_AND_DOWNLOADS";
            $data = Stage::esp($parameters, $name, $method);

            $temp = [];
            foreach ($data as $download) {
                $downloadInstance = self::createInstance($download);
                array_push($temp, $downloadInstance);
            }

            return $temp;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * queryCount
     *
     * @param \Stage\Asset\Download\Query $q
     * @return mixed
     * @throws Exception
     */
    public static function queryCount(Query $q)
    {
        $field = $q->by;
        $query = $q->term;
        $filter = $q->filter;

        try {
            $parameters = [ [$field, PDO::PARAM_INT],
                            [$query, PDO::PARAM_INT],
                            [$filter,PDO::PARAM_STR]];

            $name = "ARCHIVE_SHARE_AND_DOWNLOADS_COUNT";

            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);
            return (int) $data[0]['total'];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * find
     *
     * Find a Asset
     *
     * @return $this
     * @throws Exception
     */
    public static function find($id)
    {
        try {
            $name = "ARCHIVE_SHARE_AND_DOWNLOAD";
            $method = "GET";
            $parameters = [[$id, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);

            if (isset($data[0]['return_code']) && $data[0]['return_code'] == "-2") {
                throw new Exception("The Download id $id not exists.", $data[0]['return_code']);
            } else {
                return self::createInstance($data[0]);
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * save
     *
     * Save a Asset
     *
     * @return $this
     * @throws Exception
     */
    public function save()
    {
        $parameters = [ [$this->getId(), PDO::PARAM_INT],
                        [$this->getType(), PDO::PARAM_INT],
                        [$this->getName(), PDO::PARAM_STR],
                        [$this->getCode(), PDO::PARAM_STR],
                        [$this->getPassword(), PDO::PARAM_STR],
                        [$this->getEndDate(), PDO::PARAM_STR],
                        [$this->getActive(), PDO::PARAM_BOOL],
                        [$this->getTerm(), PDO::PARAM_STR],
                        [$this->getIdDirectory(), PDO::PARAM_STR],
                        [$this->getTag(), PDO::PARAM_STR],
                        [$this->getSystemTag(), PDO::PARAM_STR],
                        [$this->getSystemTagValue(), PDO::PARAM_STR],
                        [$this->getRoom(), PDO::PARAM_STR],
                        [$this->getIdUser(), PDO::PARAM_STR],
                        [$this->getOrderBy(), PDO::PARAM_STR]];

        try {
            $name = "ARCHIVE_SHARE_AND_DOWNLOAD";
            $method = "SET";
            $data = Stage::esp($parameters, $name, $method);

            $this->setId($data[0]['id_shr_dld']);
            \Stage\Events\Event::fire("archive.download.created", $this);

            return $this;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * delete
     *
     * Delete a Asset from the database or mark it to be deleted
     *
     * @param $idAsset
     * @param bool $softDelete
     * @param bool $deleted
     * @throws Exception
     */
    public static function delete($idAsset, $softDelete = true, $deleted = true)
    {
        $name = "ARCHIVE_SHARE_AND_DOWNLOAD";
        $parameters = [[$idAsset, PDO::PARAM_INT]];
        $method = "DEL";

        try {
            $data = Stage::esp($parameters, $name, $method);

            if (isset($data[0]['return_code']) && $data[0]['return_code'] == "-2") {
                throw new Exception("The Download id $idAsset not exists in database", $data[0]['return_code']);
            }

            return $idAsset;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $id
     * @param $field
     * @param $filter
     * @return array
     * @throws Exception
     */
    public function addContent($field, $filter)
    {
        $name = "ARCHIVE_CONTENT_TO_SHARE_AND_DOWNLOAD";
        $parameters = [[$this->getId(), PDO::PARAM_INT],
                        [$field, PDO::PARAM_STR],
                        [$filter, PDO::PARAM_STR]];
        $method = "SET";

        try {
            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * getContent
     *
     * @param $field
     * @param $filter
     * @return array
     * @throws Exception
     */
    public function getContent($field, $from, $to)
    {
        $name = "ARCHIVE_SHARE_AND_DOWNLOAD_CONTENT";
        $parameters = [[$this->getId(), PDO::PARAM_INT],
                       [$field, PDO::PARAM_INT],
                       [$from, PDO::PARAM_INT],
                       [$to, PDO::PARAM_INT]];

        $method = "GET";

        try {
            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $attribute == "name" || $attribute == "nameStripped" || $attribute == "imageTitle" || $attribute == "imageAlterText" ? html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8') : $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param  array  $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    /**
     * createInstance
     *
     * @param $data
     */
    public static function createInstance($asset)
    {
        $sd = new self();
        $sd->setId($asset['id_shr_dld']);

        $sd->setType($asset['type']);
        $sd->setName(html_entity_decode($asset['name'], ENT_COMPAT, 'UTF-8'));
        $sd->setCode($asset['code']);
        $sd->setPassword($asset['password']);
        $sd->setActive($asset['active']);
        $sd->setTerm($asset['term']);
        $sd->setDirectoryId($asset['id_directory']);
        $sd->setTag($asset['tag']);
        $sd->setSystemTag($asset['system_tag']);
        $sd->setSystemTagValue($asset['system_tag_value']);
        $sd->setRoom($asset['room']);
        $sd->setIdUser($asset['id_user']);
        $sd->setOrderBy($asset['order_by']);

        if (Helper::isValidDate($asset['end_date'], "Y-m-d H:i:s")) {
            $sd->setEndDate((new DateTime($asset['end_date']))->format(DATE_ATOM));
        }

        if (Helper::isValidDate($asset['register_date'], "Y-m-d H:i:s")) {
            $sd->setRegisterDate((new DateTime($asset['register_date']))->format(DATE_ATOM));
        }

        return $sd;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
