<?php namespace Stage\Asset;

class Query
{
    const ALL           = 0;  // name, description and tags
    const NAME          = 1;
    const DESCRIPTION   = 2;
    const TAGS          = 1000;  // tags separated with % (tag1%tag2%...)
    const MONTH         = 4;
    const YEAR          = 5;
    const STATE         = 6;
    const MIME_TYPE     = 7;
    const DIMENSION     = 8;
    const SIZE          = 9;
    const LASTX         = 14;
    const DATE_COMPLETE = 11;
    const DATE_YEAR_MONTH    = 12;
    const DATE_YEAR     = 13;
    const FILENAME      = 106;
    const ASSET         = 100;
    const WITH_LABELS   = 107;
    const BY_LABEL_ID   = 108;

    const BY_ROOM       = 104;
    const BY_ALBUM      = 105;

    const ORDER_BY_NAME_ASC  = 11000;
    const ORDER_BY_NAME_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC  = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    const ORDER_BY_SIZE_ASC  = 11002;
    const ORDER_BY_SIZE_DESC = 10002;

    const ORDER_BY_EXTENSION_ASC  = 11003;
    const ORDER_BY_EXTENSION_DESC = 10003;

    /**
     * @var
     */
    public $idDirectory = 0;

    /**
     * @var
     */
    public $room = "";

    /**
     * @var
     */
    public $idUser = 0;

    /**
     * @var
     */
    public $idAsset = 0;

    /**
     * @var
     */
    public $by = 0;

    /**
     * @var
     */
    public $sndBy = 0;

    /**
     * @var
     */
    public $trdBy = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $termTag = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $sndFilter = "";

    /**
     * @var
     */
    public $trdFilter = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $fromSize = 0;

    /**
     * @var
     */
    public $toSize = 0;

    /**
     * @var
     */
    public $orderBy = 0;

    /**
     * @var
     */
    public $order = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }
}
