<?php namespace Stage;

use PDO;
use Exception;

class Currency
{
    /**
     * @var
     */
    private $iso;

    /**
     * @var
     */
    private $name;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('iso', 'name', 'symbol');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array();

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = array();


    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model


    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = array();
    private $symbol;

    public function getIso()
    {
        return $this->iso;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setIso($iso)
    {
        $this->iso = $iso;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setSymbol($symbol)
    {
        $this->symbol = $symbol;
    }

    public static function all($lang)
    {
        $temp = [];
        $parameters = [];

        try {
            $name = "CURRENCIES";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);

            foreach ($data as $i) {
                $countryInstance = new self();
                $countryInstance->setIso($i['iso3']);
                $countryInstance->setName($i['printable_name']);
                $countryInstance->setSymbol($i['symbol']);

                array_push($temp, $countryInstance);
            }

            return $temp;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson($options = 0)
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $this->$attribute;
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param  array  $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        /*
        print_r(array_flip($this->hidden));
        print_r(array_flip($values));
        print_r(array_diff_key(array_flip($values),array_flip($this->hidden)));
        */
        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }
}
