<?php namespace Stage;

use Exception;

class L10n
{
    /**
     * @var
     */
    private $iso;

    /**
     * @var
     */
    private $language;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('iso','language');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    public function getIso()
    {
        return $this->iso;
    }

    public function getLanguage()
    {
        return $this->language;
    }


    private function setIso($iso)
    {
        $this->iso = $iso;
    }

    public function setLanguage($lang)
    {
        $this->language = $lang;
    }

    public static function all()
    {
        $parameters = [ ];

        try {
            $name = "LANGUAGES";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);

            $temp = array();
            foreach ($data as $lang) {
                $temp[] = self::createInstance($lang);
            }
            return $temp;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $this->$attribute;
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return L10n
     */
    public static function createInstance($data)
    {
        $instance = new self();
        $instance->setIso($data['iso']);
        $instance->setLanguage($data['language']);

        return $instance;
    }
}
