<?php namespace Stage\Live\Compose;

class LiveToVideoCandidate
{

    /**
     * @var
     */
    private $idLive = -1;

    /**
     * @var
     */
    private $idVideo;

    /**
     * @var
     */
    private $idComposed;

    /**
     * @var
     */
    private $videoDate;

    /**
     * @var
     */
    private $seconds;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('idLive', 'idComposed', 'idVideo', 'videoDate', 'seconds');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    public function getIdLive()
    {
        return $this->idLive;
    }

    public function getIdVideo()
    {
        return $this->idVideo;
    }

    public function getIdComposed()
    {
        return $this->idComposed;
    }

    public function getVideoDate()
    {
        return $this->videoDate;
    }

    public function getSeconds()
    {
        return $this->seconds;
    }

    private function setIdLive($id)
    {
        $this->idLive = (int)$id;
    }

    private function setIdVideo($id)
    {
        $this->idVideo = (int)$id;
    }

    private function setIdComposed($id)
    {
        $this->idComposed = (int)$id;
    }

    private function setVideoDate($date)
    {
        $this->videoDate = $date;
    }

    private function setSeconds($seconds)
    {
        $this->seconds = $seconds;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($this->$attribute != null) {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return LiveToVideoCandidate
     */
    public static function createInstance($data)
    {
        if (isset($data[0])) {
            $data = $data[0];
        }

        $compose = new self();
        $compose->setIdLive($data['id_live']);
        $compose->setIdComposed($data['id_composed']);
        $compose->setIdVideo($data['id_video']);
        $compose->setVideoDate($data['video_date']);
        $compose->setSeconds($data['seconds']);
        return $compose;
    }

    public function __toString()
    {
        return "My id is: {$this->getIdLive()}\n";
    }
}
