<?php namespace Stage\Live\Profile;

class Query
{
    const ALL           = 0;  // name, description and tags
    const NAME          = 1;
    const DESCRIPTION   = 2;
    const TAGS          = 1000;  // tags separated with % (tag1%tag2%...)
    const MONTH         = 4;
    const YEAR          = 5;
    const STATE         = 6;

    const BY_PROFILE_ID     = 100;  // profile:id
    const BY_COMPOSE_ID     = 101;  // compose:id
    const BY_PLAYLIST_ID    = 102;  // playlist:id
    const BY_STATE_ID       = 103;
    const IN_COMPOSE        = 104;
    const IN_PLAYLIST       = 105;

    const ORDER_BY_TITLE_ASC  = 11000;
    const ORDER_BY_TITLE_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC  = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    /**
     * @var
     */
    public $by;

    /**
     * @var
     */
    public $sndBy = 0;

    /**
     * @var
     */
    public $trdBy = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $sndFilter = "";

    /**
     * @var
     */
    public $trdFilter = "";

    /**
     * @var
     */
    public $isoLanguage = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $orderBy = 0;

    /**
     * @var
     */
    public $order = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }
}
