<?php namespace Stage\Live\Queue;

use PDO;
use Exception;
use Stage\Stage;

class Clip
{

    /**
     * @var
     */
    private $idAccount;

    /**
     * @var
     */
    private $accountToken;

    /**
     * @var
     */
    private $command;

    /**
     * @var
     */
    private $server;

    /**
     * @var
     */
    private $application;

    /**
     * @var
     */
    private $stream;

    /**
     * @var
     */
    private $converterStartTime;

    /**
     * @var
     */
    private $converterEndTime;

    /**
     * @var
     */
    private $converterDuration;

    /**
     * @var
     */
    private $converterTimeType;

    /**
     * @var
     */
    private $converterTolerance;

    /**
     * @var
     */
    private $converterOutputFilename;

    /**
     * @var
     */
    private $converterInterleaveDelay;

    /**
     * @var
     */
    private $converterDebugConversions;

    /**
     * @var
     */
    private $converterDefaultFileDestination;

    /**
     * @var
     */
    private $state;

    /**
     * @var
     */
    private $statusCode;

    /**
     * @var
     */
    private $videoName;

    /**
     * @var
     */
    private $version;

    /**
     * @var
     */
    private $download;

    /**
     * @var
     */
    private $dvrStartTime;

    public function getIdAccount()
    {
        return $this->idAccount;
    }

    public function getAccountToken()
    {
        return $this->accountToken;
    }

    public function getCommand()
    {
        return $this->command;
    }

    public function getServer()
    {
        return $this->server;
    }

    public function getApplication()
    {
        return $this->application;
    }

    public function getStream()
    {
        return $this->stream;
    }

    public function getConverterStartTime()
    {
        return $this->converterStartTime;
    }

    public function getConverterEndTime()
    {
        return $this->converterEndTime;
    }

    public function getConverterDuration()
    {
        return $this->converterDuration;
    }

    public function getConverterTimeType()
    {
        return $this->converterTimeType;
    }

    public function getConverterTolerance()
    {
        return $this->converterTolerance;
    }

    public function getConverterOutputFilename()
    {
        return $this->converterOutputFilename;
    }

    public function getConverterInterleaveDelay()
    {
        return $this->converterInterleaveDelay;
    }

    public function getConverterDebugConversions()
    {
        return $this->converterDebugConversions;
    }

    public function getConverterDefaultFileDestination()
    {
        return $this->converterDefaultFileDestination;
    }

    public function getState()
    {
        return $this->state;
    }

    public function getStatusCode()
    {
        return $this->statusCode;
    }

    public function getVideoName()
    {
        return $this->videoName;
    }

    public function getVersion()
    {
        return $this->version;
    }

    public function getDownload()
    {
        return $this->download;
    }

    public function getDvrStartTime()
    {
        return $this->dvrStartTime;
    }

    public function setIdAccount($idAccount)
    {
        return $this->idAccount = $idAccount;
    }

    public function setAccountToken($accountToken)
    {
        return $this->accountToken = $accountToken;
    }

    public function setCommand($command)
    {
        return $this->command = $command;
    }

    public function setServer($server)
    {
        return $this->server = $server;
    }

    public function setApplication($application)
    {
        return $this->application = $application;
    }

    public function setStream($stream)
    {
        return $this->stream = $stream;
    }

    public function setConverterStartTime($time)
    {
        return $this->converterStartTime = $time;
    }

    public function setConverterEndTime($time)
    {
        return $this->converterEndTime = $time;
    }

    public function setConverterDuration($time)
    {
        return $this->converterDuration = $time;
    }

    public function setConverterTimeType($converterTimeType)
    {
        return $this->converterTimeType = $converterTimeType;
    }

    public function setConverterTolerance($converterTolerance)
    {
        $this->converterTolerance = $converterTolerance;
    }

    public function setConverterOutputFilename($converterOutputFilename)
    {
        return $this->converterOutputFilename = $converterOutputFilename;
    }

    public function setConverterInterleaveDelay($converterInterleaveDelay)
    {
        return $this->converterInterleaveDelay = $converterInterleaveDelay;
    }

    public function setConverterDebugConversions($converterDebugConversions)
    {
        return $this->converterDebugConversions = $converterDebugConversions;
    }

    public function setConverterDefaultFileDestination($converterDefaultFileDestination)
    {
        return $this->converterDefaultFileDestination = $converterDefaultFileDestination;
    }

    public function setState($state)
    {
        return $this->state = $state;
    }

    public function setStatusCode($statusCode)
    {
        return $this->statusCode = $statusCode;
    }

    public function setVideoName($videoName)
    {
        return $this->videoName = $videoName;
    }

    public function setVersion($version)
    {
        return $this->version = $version;
    }

    public function setDownload($download)
    {
        return $this->download = $download;
    }

    public function setDvrStartTime($dvrStartTime)
    {
        return $this->dvrStartTime = $dvrStartTime;
    }

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('idAccount','accountToken','command','server', 'application','stream','converterStartTime','converterEndTime','converterDuration','converterTimeType','converterTolerance','converterOutputFilename','converterInterleaveDelay','converterDebugConversions','converterDefaultFileDestination','state','statusCode','videoName','version');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    /**
     * save
     *
     * @return $this
     * @throws Exception
     */
    public function save()
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP";
            $method = "SET";
            $parameters = [[$this->getIdAccount(), PDO::PARAM_INT],
                           [$this->getAccountToken(), PDO::PARAM_STR],
                           [$this->getCommand(), PDO::PARAM_STR],
                           [$this->getServer(), PDO::PARAM_STR],
                           [$this->getApplication(), PDO::PARAM_STR],
                           [$this->getStream(), PDO::PARAM_STR],
                           [$this->getConverterStartTime(), PDO::PARAM_STR],
                           [$this->getConverterEndTime(), PDO::PARAM_STR],
                           [$this->getConverterDuration(), PDO::PARAM_STR],
                           [$this->getConverterTimeType(), PDO::PARAM_STR],
                           [$this->getConverterTolerance(), PDO::PARAM_INT],
                           [$this->getConverterOutputFilename(), PDO::PARAM_STR],
                           [$this->getConverterInterleaveDelay(), PDO::PARAM_INT],
                           [$this->getConverterDebugConversions(), PDO::PARAM_BOOL],
                           [$this->getConverterDefaultFileDestination(), PDO::PARAM_STR],
                           [$this->getState(), PDO::PARAM_STR],
                           [$this->getStatusCode(), PDO::PARAM_STR],
                           [$this->getVideoName(), PDO::PARAM_STR],
                           [$this->getVersion(), PDO::PARAM_STR],
                           [$this->getDownload(), PDO::PARAM_STR],
                           [$this->getDvrStartTime(), PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);

            if (!sizeof($data)) {
                throw new Exception("Error pushing to live create clip queue");
            } else {
                return $data;
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idAccount
     * @return array
     * @throws Exception
     */
    public static function listItems($field, $idAccount, $isRunning = -1, $stream)
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP_QUEUE";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                           [$idAccount, PDO::PARAM_INT],
                           [$isRunning, PDO::PARAM_INT],    // 0 - false , 1 - true
                           [$stream, PDO::PARAM_STR]];

            return Stage::esp($parameters, $name, $method);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * current
     *
     * Get the current clip being processed
     *
     * @param int $field
     * @return mixed|Job
     * @throws Exception
     */
    public static function current()
    {
        try {
            return self::listItems(-1, 1);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * next
     *
     * Get the next clip to process
     *
     * @param int $field
     * @return mixed|Job
     * @throws Exception
     */
    public static function next($field = 0, $machine = "")
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP_TO_PROCESS";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                           [$machine, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data[0];
            // return isset($data[0]) && isset($data[0]['return_code']) ? [] : Job::createInstance($data[0]);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * done
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function done($idQueue, $machine, $field = 1)
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT],
                           [$machine, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * retry
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function retry($idQueue, $field = 1, $state, $statusCode)
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP_NOT_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT],
                           [$state, PDO::PARAM_STR],
                           [$statusCode, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idQueue
     * @param $state
     * @param $statusCode
     * @return array
     * @throws Exception
     */
    public static function clipState($idQueue, $state, $statusCode)
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP_STATE";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$state, PDO::PARAM_STR],
                           [$statusCode, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idQueue
     * @return array|mixed
     * @throws Exception
     */
    public static function delete($idQueue)
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP";
            $method = "DEL";
            $parameters = [[$idQueue, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data[0];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idQueue
     * @param bool $hide
     * @return array|mixed
     * @throws Exception
     */
    public static function hide($field, $idAccount, $idQueue, $stream, $hide = true)
    {
        try {
            $name = "TASK_LIVE_CREATE_CLIP_HIDE_COMPLETED";
            $method = "SET";
            $parameters = [[$field, PDO::PARAM_INT],
                           [$idAccount, PDO::PARAM_INT],
                           [$idQueue, PDO::PARAM_INT],
                           [$hide, PDO::PARAM_BOOL],
                           [$stream, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data[0];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $attribute == "account" ? $this->getAccount()->toArray() : $this->$attribute;
        }

        return $arr;
    }

    public function __toString()
    {
        $p = array_map(function ($var) {
            return "'" . $var . "'";
        }, get_object_vars($this));

        return implode(',', $p);
    }
}
