<?php namespace Stage\Loader;

use DateTime;
use PDO;
use Exception;
use Stage\Stage;

class Loader
{

    /**
     * push
     *
     * Save a tag to the database and return a Tag instance
     *
     * @throws Exception
     */
    public static function push($idQueue, $idProfile, $idPlaylist, $publishDate, $beginDate, $endDate)
    {
        try {
            $publishDate = $publishDate == null ? "" : $publishDate->format(DateTime::ATOM);
            $beginDate = $beginDate == null ? "" : $beginDate->format(DateTime::ATOM);
            $endDate = $endDate == null ? "" : $endDate->format(DateTime::ATOM);

            $name = "PUSH_VIDEO_DETAILS";
            $method = "SET";
            $parameters = [ [$idQueue, PDO::PARAM_INT],
                            [$idProfile, PDO::PARAM_INT],
                            [$idPlaylist, PDO::PARAM_INT],
                            [$publishDate, PDO::PARAM_STR],
                            [$beginDate, PDO::PARAM_STR],
                            [$endDate, PDO::PARAM_STR]];

            return Stage::esp($parameters, $name, $method);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idQueue
     * @return array
     * @throws Exception
     */
    public static function get($idQueue)
    {
        try {
            $name = "PUSH_VIDEO_DETAILS";
            $method = "GET";
            $parameters = [ [$idQueue, PDO::PARAM_INT]];

            return Stage::esp($parameters, $name, $method);
        } catch (Exception $e) {
            throw $e;
        }
    }
}
