<?php namespace Stage\Oir;

use PDO;
use Exception;
use Stage\Stage;

class Oir
{
    public static function next($field, $machine, $requester, $total)
    {
        try {
            $name = "TASK_OIR_TO_PROCESS";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                [$machine, PDO::PARAM_STR],
                [$requester, PDO::PARAM_STR],
                [$total, PDO::PARAM_INT]];

            $result = Stage::esp($parameters, $name, $method);
            return OirCommand::isValid($result) ? array_map(function ($command) {
                return OirCommand::factory($command);
            }, $result) : false;
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function retry($idQueue, $field)
    {
        try {
            $name = "TASK_OIR_NOT_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT]];
            return Stage::esp($parameters, $name, $method);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public static function done($idQueue, $field)
    {
        try {
            $name = "TASK_OIR_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                [$field, PDO::PARAM_INT]];

            return Stage::esp($parameters, $name, $method);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idAccount
     * @param $accountToken
     * @param $command
     * @param $requester
     * @return bool
     * @throws Exception
     */
    public static function push($idAccount, $accountToken, $command, $requester)
    {
        try {
            // write on table oir_queue, oir_requests
            $name = "TASK_OIR";
            $method = "SET";
            $parameters = [[$idAccount, PDO::PARAM_INT],
                [$accountToken, PDO::PARAM_INT],
                [$command, PDO::PARAM_INT],
                [$requester, PDO::PARAM_STR]];

            $result = Stage::esp($parameters, $name, $method);
            return isset($result[0]) && isset($result[0]['return_code']) && $result[0]['return_code'] == "0" ? true : false;
        } catch (Exception $e) {
            throw $e;
        }
    }
}
