<?php namespace Stage\Post\Author;

use DateTime;
use PDO;
use Stage\Asset\Asset;
use Stage\Helper;
use Stage\Post\Author\Key\Variant;
use Stage\Stage;
use Exception;
use Stage\Exception\StoredProcedure as StoredProcedureException;

class L10n
{

    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idAuthor;

    /**
     * @var
     */
    private $isoLanguage = "";

    /**
     * @var
     */
    private $name = "";

    /**
     * @var
     */
    private $email = "";

    /**
     * @var
     */
    private $description = "";

    /**
     * @var
     */
    private $role = "";

    /**
     * @var
     */
    private $biography = "";

    /**
     * @var
     */
    private $metaTitle = "";

    /**
     * @var
     */
    private $metaDescription = "";

    /**
     * @var
     */
    private $metaImage = "";

    /**
     * @var
     */
    private $metaUrl = "";

    /**
     * @var
     */
    private $image = "";

    /**
     * @var
     */
    private $imageAlign = "";

    /**
     * @var
     */
    private $imageWidth = 0;

    /**
     * @var
     */
    private $imageHeight = 0;

    /**
     * @var
     */
    private $imageTitle = "";

    /**
     * @var
     */
    private $imageAlterText = "";

    /**
     * @var
     */
    private $metaKeywords = "";

    /**
     * @var
     */
    private $metaSync = "";

    /**
     * @var
     */
    private $isPublic = true;

    /**
     * @var
     */
    private $total;

    /**
     * @var
     */
    private $metaIdAsset = 0;

    /**
     * @var
     */
    private $idAsset = 0;

    /**
     * @var
     */
    private $position = 0;

    /**
     * @var
     */
    private $isosEnumeration = "";

    /**
     * @var
     */
    private $registerDate = "";

    /**
     * @var
     */
    private $updateDate = "";

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idAuthor', 'isoLanguage', 'name', 'email', 'description', 'role', 'biography', 'image', 'imageAlign', 'imageWidth', 'imageHeight', 'metaTitle', 'metaDescription', 'metaImage', 'imageTitle', 'imageAlterText', 'metaKeywords', 'metaSync', 'isPublic', 'metaUrl', 'total', 'metaIdAsset', 'idAsset', 'position', 'isosEnumeration', 'registerDate', 'updateDate');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdAuthor()
    {
        return $this->idAuthor;
    }

    public function getIsoLanguage()
    {
        return $this->isoLanguage;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getEmail()
    {
        return $this->email;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function getRole()
    {
        return $this->role;
    }

    public function getBiography()
    {
        return $this->biography;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getImageAlign()
    {
        return $this->imageAlign;
    }

    public function getImageWidth()
    {
        return $this->imageWidth;
    }

    public function getImageHeight()
    {
        return $this->imageHeight;
    }

    public function getMetaTitle()
    {
        return $this->metaTitle;
    }

    public function getMetaDescription()
    {
        return $this->metaDescription;
    }

    public function getMetaImage()
    {
        return $this->metaImage;
    }

    public function getImageTitle()
    {
        return $this->imageTitle;
    }

    public function getImageAlterText()
    {
        return $this->imageAlterText;
    }

    public function getMetaKeywords()
    {
        return $this->metaKeywords;
    }

    public function getMetaSync()
    {
        return $this->metaSync;
    }

    public function isPublic()
    {
        return $this->isPublic;
    }

    public function getMetaUrl()
    {
        return $this->metaUrl;
    }

    public function getTotal($total)
    {
        return (int)$this->total;
    }

    public function getMetaIdAsset()
    {
        return $this->metaIdAsset;
    }

    public function getIdAsset()
    {
        return $this->idAsset;
    }

    public function getPosition()
    {
        return $this->position;
    }

    public function getIsosEnumeration()
    {
        return $this->isosEnumeration;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    public function setId($id)
    {
        $this->id = (int)$id;
    }

    public function setIdAuthor($id)
    {
        $this->idAuthor = (int)$id;
    }

    public function setIsoLanguage($isoLanguage)
    {
        $this->isoLanguage = $isoLanguage;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setEmail($email)
    {
        $this->email = $email;
    }

    public function setDescription($desc)
    {
        $this->description = $desc;
    }

    public function setRole($role)
    {
        $this->role = $role;
    }

    public function setBiography($bio)
    {
        $this->biography = $bio;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageAlign($imageAlign)
    {
        $this->imageAlign = $imageAlign;
    }

    public function setImageWidth($width)
    {
        $this->imageWidth = $width;
    }

    public function setImageHeight($height)
    {
        $this->imageHeight = $height;
    }

    public function setMetaTitle($title)
    {
        $this->metaTitle = $title;
    }

    public function setMetaDescription($desc)
    {
        $this->metaDescription = $desc;
    }

    public function setMetaImage($image)
    {
        $this->metaImage = $image;
    }

    public function setImageTitle($title)
    {
        $this->imageTitle = $title;
    }

    public function setImageAlterText($imageAlterText)
    {
        $this->imageAlterText = $imageAlterText;
    }

    public function setMetaKeywords($metaKeywords)
    {
        $this->metaKeywords = $metaKeywords;
    }

    public function setMetaSync($sync)
    {
        $this->metaSync = (bool)$sync;
    }

    public function setIsPublic($is)
    {
        $this->isPublic = (bool) $is;
    }

    public function setTotal($total)
    {
        $this->total = $total;
    }

    public function setMetaIdAsset($metaIdAsset)
    {
        $this->metaIdAsset = $metaIdAsset;
    }

    public function setIdAsset($idAsset)
    {
        $this->idAsset = $idAsset;
    }

    public function setPosition($position)
    {
        $this->position = $position;
    }

    public function setMetaUrl($metaUrl)
    {
        $this->metaUrl = $metaUrl;
    }

    public function setIsosEnumeration($isos)
    {
        $this->isosEnumeration = $isos;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    /**
     * save
     *
     * @param Author $author
     * @throws Exception
     */
    public function save()
    {
        try {
            $name = "POSTS_AUTHOR_L10N";
            $method = "SET";
            $parameters = [[$this->getId(), PDO::PARAM_INT],
                [$this->getIdAuthor(), PDO::PARAM_INT],
                [$this->getIsoLanguage(), PDO::PARAM_STR],
                [$this->getName(), PDO::PARAM_STR],
                [$this->getEmail(), PDO::PARAM_STR],
                [$this->getDescription(), PDO::PARAM_STR],
                [$this->getRole(), PDO::PARAM_STR],
                [$this->getBiography(), PDO::PARAM_STR],
                [$this->getImage(), PDO::PARAM_STR],
                [$this->getImageAlign(), PDO::PARAM_STR],
                [$this->getImageTitle(), PDO::PARAM_STR],
                [$this->getImageAlterText(), PDO::PARAM_STR],
                [$this->getMetaTitle(), PDO::PARAM_STR],
                [$this->getMetaDescription(), PDO::PARAM_STR],
                [$this->getMetaImage(), PDO::PARAM_STR],
                [$this->getMetaUrl(), PDO::PARAM_STR],
                [$this->getMetaKeywords(), PDO::PARAM_STR],
                [$this->getMetaSync(), PDO::PARAM_BOOL],
                [$this->isPublic(), PDO::PARAM_BOOL]];

            $data = Stage::esp($parameters, $name, $method);
            if (isset($data[0]['id_author_l10n'])) {
                $this->setId($data[0]['id_author_l10n']);
                if (isset($data[0]['register_date']) && Helper::isValidDate($data[0]['register_date'], "Y-m-d H:i:s")) {
                    $this->setRegisterDate(new DateTime($data[0]['register_date']));
                }

                if (isset($data[0]['update_date']) && Helper::isValidDate($data[0]['update_date'], "Y-m-d H:i:s")) {
                    $this->setUpdateDate(new DateTime($data[0]['update_date']));
                }
                return $this;
            } else {
                throw new Exception("Error saving Author L10n", $data[0]['return_code']);
            }

        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * duplicate
     *
     * Returns a new Collection duplicated, with a new Collection id
     *
     * @return $this
     * @throws Exception
     */
    public function duplicate($idAuthorClone)
    {
        try {
            $parameters = [[$this->getId(), PDO::PARAM_INT],
                [$idAuthorClone, PDO::PARAM_INT]];
            $name = "POSTS_AUTHOR_CLONE_L10N";
            $method = "SET";
            $data = Stage::esp($parameters, $name, $method);
            return self::createInstance($data);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * attachAsset
     *
     * Associate a Asset to a L10n
     * @param $idAsset
     * @return bool
     * @throws Exception
     */
    public function attachAsset($idAsset)
    {
        $name = "POSTS_AUTHORS_L10N_PHOTOS";
        $method = "SET";
        $parameters = [[$this->getId(), PDO::PARAM_INT],
            [$idAsset, PDO::PARAM_INT]];

        $result = Stage::esp($parameters, $name, $method);
        return isset($result[0]) && isset($result[0]['return_code']) && $result[0]['return_code'] == "0";
    }

    /**
     * detachAllAssets
     *
     * Detach all Asset's attached to this L10n
     * @throws Exception
     */
    public function detachAllAssets()
    {
        $name = "POSTS_AUTHORS_L10N_PHOTOS";
        $method = "DEL";
        $parameters = [[$this->getId(), PDO::PARAM_INT]];
        $result = Stage::esp($parameters, $name, $method);
        return isset($result[0]) && isset($result[0]['return_code']) && $result[0]['return_code'] == "0";
    }

    /**
     * @return \Stage\Post\MyArrayObject
     * @throws Exception
     */
    public function assets()
    {
        $name = "POSTS_AUTHORS_L10N_PHOTOS";
        $method = "GET";
        $parameters = [[$this->getId(), PDO::PARAM_INT]];
        $data = Stage::esp($parameters, $name, $method);
        if (isset($data[0]) && isset($data[0]['return_code']) && $data[0]['return_code'] == "-2") {
            return new \Stage\Post\MyArrayObject([]);
        } else {
            $result = new \Stage\Post\MyArrayObject(array_map(function ($asset) {
                return Asset::createInstance($asset);
            }, $data));
            $result->setCount(sizeof($data));
            return $result;
        }
    }

    /**
     * find
     *
     * Find the L10n for an Author
     *
     * @param $idAuthor
     * @param $idAuthorL10n
     * @return mixed
     * @throws StoredProcedureException
     */
    public static function find($idAuthor, $idAuthorL10n)
    {
        try {
            $result = self::all($idAuthor, "", $idAuthorL10n);
            if (isset($result[0]) && isset($result[0]['id_author'])) {
                return self::createInstance($result[0]);
            } else {
                throw new Exception("The Author L10n id $idAuthorL10n not exists or stored procedure error.");
            }
        } catch (StoredProcedureException $e) {
            throw $e;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * all
     *
     * Return all L10n of a specific collection
     *
     * @param $idAuthor
     * @param string $isoLanguage , If the string is empty all l10ns will be returned
     * @param null $idL10n
     * @return \Stage\Post\MyArrayObject|array
     * @throws StoredProcedureException
     */
    public static function all($idAuthor, $isoLanguage = "", $idL10n = null)
    {
        $parameters = [[$idAuthor, PDO::PARAM_INT],
            [$isoLanguage, PDO::PARAM_STR]];

        try {
            $name = "POSTS_AUTHOR_L10N";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);

            if ($idL10n) {
                return array_values(array_filter($data, function ($l10n) use ($idL10n) {
                    return $l10n['id_author_l10n'] == $idL10n;
                }));
            } else {
                $result = new \Stage\Post\MyArrayObject(array_map(function ($l10n) {
                    return self::createInstance($l10n);
                }, $data));
                $result->setCount(sizeof($data));
                return $result;
            }
        } catch (StoredProcedureException $e) {
            throw $e;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * delete
     *
     * @param $idL10n
     * @return bool
     * @throws Exception
     */
    public static function delete($idL10n)
    {
        try {
            $name = "POSTS_AUTHOR_L10N";
            $method = "DEL";
            $parameters = [[$idL10n, PDO::PARAM_INT]];
            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) && $data[0]['return_code'] == "0";
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * variantKeys
     *
     * Get all Variant Keys
     * @return \Stage\Post\MyArrayObject
     */
    public function variantKeys()
    {
        $idAuthorL10n = $this->getId();
        $name = "POSTS_AUTHORS_VARIANTS_RELATED";
        $method = "GET";
        $parameters = [[$idAuthorL10n, PDO::PARAM_INT]];
        $data = Stage::esp($parameters, $name, $method);

        $result = new \Stage\Post\MyArrayObject(array_filter(array_map(function ($variant) {
            return isset($variant['id_variant']) ? Variant::createInstance($variant) : [];
        }, $data), function ($item) {
            return $item;
        }));
        $result->setCount($result->count());
        return $result;
    }

    /**
     * attachVariantKey
     *
     * Associate a Variant Key to a L10n
     * @param $idKey
     * @param $variantValue
     * @param $position
     * @return bool
     * @throws Exception
     */
    public function attachVariantKey($idKey, $variantValue, $position)
    {
        // table: posts_authors_variants_related
        $idAuthorL10n = $this->getId();
        $name = "POSTS_AUTHORS_VARIANTS";
        $method = "SET";
        $parameters = [[$idAuthorL10n, PDO::PARAM_INT],
            [$idKey, PDO::PARAM_INT],
            [$variantValue, PDO::PARAM_STR],
            [$position, PDO::PARAM_INT]];

        try {
            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['id_variant']) && $data[0]['id_variant'];
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * detachVariantKey
     *
     * @param $idAuthorL10n
     * @param $idKey
     * @throws Exception
     */
    public function detachVariantKey($idKey)
    {
        $idAuthorL10n = $this->getId();
        $name = "POSTS_AUTHORS_VARIANT";
        $method = "DEL";
        $parameters = [[$idAuthorL10n, PDO::PARAM_INT],
            [$idKey, PDO::PARAM_INT]];
        $data = Stage::esp($parameters, $name, $method);
        return isset($data[0]) && isset($data[0]['return_code']) && $data[0]['return_code'] == 0;
    }

    /**
     * detachAllVariantKeys
     *
     * @return bool
     * @throws Exception
     */
    public function detachAllVariantKeys()
    {
        $status = true;
        /** @var Variant[] $variants */
        $variants = $this->variantKeys();
        foreach ($variants as $variant) {
            $status = $this->detachVariantKey($variant->getIdKey());
        }
        return $status;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "role" || $attribute == "biography") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return \Stage\Post\Author\L10n
     */
    public static function createInstance($data)
    {
        $l10n = new self();
        $l10n->setId($data['id_author_l10n']);
        $l10n->setIdAuthor($data['id_author']);
        $l10n->setIsoLanguage($data['iso_language']);
        $l10n->setName(html_entity_decode($data['name'], ENT_COMPAT, 'UTF-8'));
        $l10n->setEmail($data['email']);
        $l10n->setDescription(html_entity_decode($data['description'], ENT_COMPAT, 'UTF-8'));
        $l10n->setRole(html_entity_decode($data['role'], ENT_COMPAT, 'UTF-8'));
        $l10n->setBiography($data['biography']);
        $l10n->setImage($data['image']);
        if (isset($data['image_align'])) {
            $l10n->setImageAlign($data['image_align']);
        }
        if (isset($data['image_width'])) {
            $l10n->setImageWidth($data['image_width']);
        }
        if (isset($data['image_height'])) {
            $l10n->setImageHeight($data['image_height']);
        }
        $l10n->setMetaTitle(html_entity_decode($data['meta_title'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaDescription(html_entity_decode($data['meta_description'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaImage($data['meta_image']);
        $l10n->setMetaUrl($data['meta_url']);
        $l10n->setImageTitle(html_entity_decode($data['image_title'], ENT_COMPAT, 'UTF-8'));
        $l10n->setImageAlterText(html_entity_decode($data['image_alter_text'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaKeywords(html_entity_decode($data['meta_keywords'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaSync($data['meta_sync']);
        $l10n->setIsPublic($data['public']);
        $l10n->setTotal($data['total']);
        $l10n->setMetaIdAsset($data['meta_id_asset']);
        $l10n->setIdAsset($data['id_asset']);
        if(isset($data['position'])) {
            $l10n->setPosition($data['position']);
        }

        if (isset($data['iso_grouped'])) {
            $l10n->setIsosEnumeration($data['iso_grouped']);
        }

        if (isset($data['register_date']) && Helper::isValidDate($data['register_date'], "Y-m-d H:i:s")) {
            $l10n->setRegisterDate(new DateTime($data['register_date']));
        }

        if (isset($data['update_date']) && Helper::isValidDate($data['update_date'], "Y-m-d H:i:s")) {
            $l10n->setUpdateDate(new DateTime($data['update_date']));
        }

        return $l10n;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
