<?php namespace Stage\Post\Collection;

use DateTime;
use PDO;
use Exception;
use Stage\Helper;
use Stage\Post\Collection\Tag\Tag;
use Stage\Stage;
use Stage\Exception\StoredProcedure as StoredProcedureException;

class L10n
{
    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idCollection;

    /**
     * @var
     */
    private $isoLanguage;

    /**
     * @var
     */
    private $name = "";

    /**
     * @var
     */
    private $description = "";

    /**
     * @var
     */
    private $image = "";

    /**
     * @var
     */
    private $imageAlign = "";

    /**
     * @var
     */
    private $imageWidth = 0;

    /**
     * @var
     */
    private $imageHeight = 0;

    /**
     * @var
     */
    private $metaTitle = "";

    /**
     * @var
     */
    private $metaDescription = "";

    /**
     * @var
     */
    private $metaImage = "";

    /**
     * @var
     */
    private $imageTitle = "";

    /**
     * @var
     */
    private $imageAlterText = "";

    /**
     * @var
     */
    private $metaKeywords = "";

    /**
     * @var
     */
    private $metaUrl = "";

    /**
     * @var
     */
    private $metaWatermarkImage = "";

    /**
     * @var
     */
    private $metaSync = "";

    /**
     * @var
     */
    private $metaIdAsset = 0;

    /**
     * @var
     */
    private $idAsset = 0;

    /**
     * @var
     */
    private $isosEnumeration = "";

    /**
     * @var
     */
    private $registerDate = "";

    /**
     * @var
     */
    private $updateDate = "";

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idCollection', 'isoLanguage', 'name', 'description', 'image', 'imageAlign','imageWidth', 'imageHeight', 'metaTitle', 'metaDescription', 'metaImage', 'imageTitle', 'imageAlterText', 'metaKeywords', 'metaUrl', 'metaWatermarkImage', 'metaSync', 'metaIdAsset', 'idAsset', 'isosEnumeration', 'registerDate', 'updateDate');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array('publishDate', 'beginDate', 'endDate');

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdCollection()
    {
        return $this->idCollection;
    }

    public function getIsoLanguage()
    {
        return $this->isoLanguage;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getImageAlign()
    {
        return $this->imageAlign;
    }

    public function getImageWidth()
    {
        return $this->imageWidth;
    }

    public function getImageHeight()
    {
        return $this->imageHeight;
    }

    public function getMetaTitle()
    {
        return $this->metaTitle;
    }

    public function getMetaDescription()
    {
        return $this->metaDescription;
    }

    public function getMetaImage()
    {
        return $this->metaImage;
    }

    public function getImageTitle()
    {
        return $this->imageTitle;
    }

    public function getImageAlterText()
    {
        return $this->imageAlterText;
    }

    public function getMetaKeywords()
    {
        return $this->metaKeywords;
    }

    public function getMetaUrl()
    {
        return $this->metaUrl;
    }

    public function getMetaWatermarkImage()
    {
        return $this->metaWatermarkImage;
    }

    public function getMetaSync()
    {
        return $this->metaSync;
    }

    public function getMetaIdAsset()
    {
        return $this->metaIdAsset;
    }

    public function getIdAsset()
    {
        return $this->idAsset;
    }

    public function getIsosEnumeration()
    {
        return $this->isosEnumeration;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    private function setId($id)
    {
        $this->id = (int)$id;
    }

    public function setIdCollection($idCollection)
    {
        $this->idCollection = $idCollection;
    }

    public function setIsoLanguage($isoLanguage)
    {
        $this->isoLanguage = $isoLanguage;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setDescription($desc)
    {
        $this->description = $desc;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageAlign($imageAlign)
    {
        $this->imageAlign = $imageAlign;
    }

    public function setImageWidth($width)
    {
        $this->imageWidth = $width;
    }

    public function setImageHeight($height)
    {
        $this->imageHeight = $height;
    }

    public function setMetaTitle($title)
    {
        $this->metaTitle = $title;
    }

    public function setMetaDescription($desc)
    {
        $this->metaDescription = $desc;
    }

    public function setMetaImage($image)
    {
        $this->metaImage = $image;
    }

    public function setImageTitle($title)
    {
        $this->imageTitle = $title;
    }

    public function setImageAlterText($imageAlterText)
    {
        $this->imageAlterText = $imageAlterText;
    }

    public function setMetaKeywords($metaKeywords)
    {
        $this->metaKeywords = $metaKeywords;
    }

    public function setMetaUrl($metaUrl)
    {
        $this->metaUrl = $metaUrl;
    }

    public function setMetaWatermarkImage($metaWatermarkImage)
    {
        $this->metaWatermarkImage = $metaWatermarkImage;
    }

    public function setMetaSync($sync)
    {
        $this->metaSync = (bool)$sync;
    }

    public function setMetaIdAsset($metaIdAsset)
    {
        $this->metaIdAsset = $metaIdAsset;
    }

    public function setIdAsset($idAsset)
    {
        $this->idAsset = $idAsset;
    }

    public function setIsosEnumeration($isos)
    {
        $this->isosEnumeration = $isos;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    /**
     * duplicate
     *
     * Returns a new Collection duplicated, with a new Collection id
     *
     * @return $this
     * @throws Exception
     */
    public function duplicate($idCollectionClone)
    {
        try {
            $parameters = [[$this->getId(), PDO::PARAM_INT],
                [$idCollectionClone, PDO::PARAM_INT]];
            $name = "POSTS_COLLECTION_CLONE_L10N";
            $method = "SET";
            $data = Stage::esp($parameters, $name, $method);
            return self::createInstance($data);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * attachTag
     *
     * Associate a Tag to a L10n
     * @param Tag $tag
     */
    public function attachTag($idTag)
    {
        $name = "POSTS_COLLECTIONS_L10N_TO_TAGS";
        $method = "SET";
        $parameters = [[$this->getId(), PDO::PARAM_INT],
            [$idTag, PDO::PARAM_INT]];

        $result = Stage::esp($parameters, $name, $method);
        return isset($result[0]) && isset($result[0]['return_code']) && $result[0]['return_code'] == "0";
    }

    /**
     * detachAllTags
     *
     * Detach all Tag's attached to this L10n
     * @throws Exception
     */
    public function detachAllTags()
    {
        $name = "POSTS_COLLECTIONS_L10N_FROM_TAGS";
        $method = "DEL";
        $parameters = [[$this->getId(), PDO::PARAM_INT]];
        $result = Stage::esp($parameters, $name, $method);
        return isset($result[0]) && isset($result[0]['return_code']) && $result[0]['return_code'] == "0";
    }

    /**
     * tags
     *
     * Return all tags related to this collection l10n
     * @return \Stage\Post\MyArrayObject|array
     * @throws Exception
     */
    public function tags()
    {
        $name = "POSTS_COLLECTION_L10N_TAGS_RELATED";
        $method = "GET";
        $parameters = [[$this->getId(), PDO::PARAM_INT]];
        $data = Stage::esp($parameters, $name, $method);

        if (isset($data[0]) && isset($data[0]['id_tag'])) {
            $result = new \Stage\Post\MyArrayObject(array_map(function ($tag) {
                return Tag::createInstance($tag);
            }, $data));
            $result->setCount(sizeof($data));
            return $result;
        } else {
            return new \Stage\Post\MyArrayObject([]);
        }
    }

    /**
     * all
     *
     * Return all L10n of a specific collection
     * @param $idCollection
     * @param string $isoLanguage
     * @param null $idL10n
     * @return array|\Stage\Post\MyArrayObject
     * @throws StoredProcedureException
     */
    public static function all($idCollection, $isoLanguage = "", $idL10n = null)
    {
        $parameters = [[$idCollection, PDO::PARAM_INT],
            [$isoLanguage, PDO::PARAM_STR]];

        try {
            $name = "POSTS_COLLECTION_L10N";
            $method = "GET";
            $data = Stage::esp($parameters, $name, $method);

            if ($idL10n) {
                return array_values(array_filter($data, function ($collection) use ($idL10n) {
                    return $collection['id_l10n'] == $idL10n;
                }));
            } else {
                $temp = [];
                foreach ($data as $l10n) {
                    $temp[] = self::createInstance($l10n);
                }
                return new \Stage\Post\MyArrayObject($temp);
            }
        } catch (StoredProcedureException $e) {
            throw $e;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $idCollection
     * @param $idL10n
     * @throws StoredProcedureException
     */
    public static function find($idCollection, $idL10n)
    {
        try {
            $result = self::all($idCollection, "", $idL10n);
            if (isset($result[0]) && isset($result[0]['id_l10n'])) {
                return self::createInstance($result[0]);
            } else {
                throw new Exception("The Collection L10n id $idL10n not exists or stored procedure error.");
            }
        } catch (StoredProcedureException $e) {
            throw $e;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * save
     *
     * Save a Dossier L10n
     *
     * @return $this
     * @throws Exception
     */
    public function save($idCollection)
    {
        $parameters = [[$this->getId(), PDO::PARAM_INT],
            [$idCollection, PDO::PARAM_INT],
            [$this->getIsoLanguage(), PDO::PARAM_STR],
            [$this->getName(), PDO::PARAM_STR],
            [$this->getDescription(), PDO::PARAM_STR],
            [$this->getImage(), PDO::PARAM_STR],
            [$this->getImageAlign(), PDO::PARAM_STR],
            [$this->getImageTitle(), PDO::PARAM_STR],
            [$this->getImageAlterText(), PDO::PARAM_STR],
            [$this->getMetaTitle(), PDO::PARAM_STR],
            [$this->getMetaDescription(), PDO::PARAM_STR],
            [$this->getMetaImage(), PDO::PARAM_STR],
            [$this->getMetaKeywords(), PDO::PARAM_STR],
            [$this->getMetaUrl(), PDO::PARAM_STR],
            [$this->getMetaWatermarkImage(), PDO::PARAM_STR],
            [$this->getMetaSync(), PDO::PARAM_BOOL]];

        try {
            $name = "POSTS_COLLECTIONS_L10N";
            $method = "SET";
            $data = Stage::esp($parameters, $name, $method);

            if (isset($data[0]['id_l10n'])) {
                $this->setId($data[0]['id_l10n']);
                if (isset($data[0]) && isset($data[0]['register_date']) && Helper::isValidDate($data[0]['register_date'], "Y-m-d H:i:s")) {
                    $this->setRegisterDate(new DateTime($data[0]['register_date']));
                }

                if (isset($data[0]) && isset($data[0]['update_date']) && Helper::isValidDate($data[0]['update_date'], "Y-m-d H:i:s")) {
                    $this->setUpdateDate(new DateTime($data[0]['update_date']));
                }
                return $this;
            } else {
                throw new Exception("Error saving Collection L10n", $data[0]['return_code']);
            }

        } catch (StoredProcedureException $e) {
            throw $e;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * delete
     *
     * @return bool
     * @throws Exception
     */
    public function delete()
    {
        try {
            $name = "POSTS_COLLECTION_L10N";
            $method = "DEL";
            $parameters = [[$this->getId(), PDO::PARAM_INT]];
            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) && $data[0]['return_code'] == "0";
        } catch (Exception $e) {
            throw $e;
        }

        return $this;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } elseif ($attribute == "name") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return L10n
     */
    public static function createInstance($data)
    {
        $l10n = new self();

        $l10n->setId($data['id_l10n']);
        $l10n->setIdCollection($data['id_collection']);
        $l10n->setIsoLanguage($data['iso_language']);
        $l10n->setName(html_entity_decode($data['name'], ENT_COMPAT, 'UTF-8'));
        $l10n->setDescription(html_entity_decode($data['description'], ENT_COMPAT, 'UTF-8'));
        $l10n->setImage($data['image']);
        if (isset($data['image_align'])) {
            $l10n->setImageAlign($data['image_align']);
        }
        if (isset($data['image_width'])) {
            $l10n->setImageWidth($data['image_width']);
        }
        if (isset($data['image_height'])) {
            $l10n->setImageHeight($data['image_height']);
        }
        $l10n->setMetaTitle(html_entity_decode($data['meta_title'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaDescription(html_entity_decode($data['meta_description'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaImage($data['meta_image']);
        $l10n->setImageTitle(html_entity_decode($data['image_title'], ENT_COMPAT, 'UTF-8'));
        $l10n->setImageAlterText(html_entity_decode($data['image_alter_text'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaKeywords(html_entity_decode($data['meta_keywords'], ENT_COMPAT, 'UTF-8'));
        $l10n->setMetaUrl($data['meta_url']);
        $l10n->setMetaWatermarkImage($data['meta_watermark_image']);
        $l10n->setMetaSync($data['meta_sync']);
        $l10n->setMetaIdAsset($data['meta_id_asset']);
        $l10n->setIdAsset($data['id_asset']);

        if (isset($data['iso_grouped'])) {
            $l10n->setIsosEnumeration($data['iso_grouped']);
        }

        if (isset($data['register_date']) && Helper::isValidDate($data['register_date'], "Y-m-d H:i:s")) {
            $l10n->setRegisterDate(new DateTime($data['register_date']));
        }

        if (isset($data['update_date']) && Helper::isValidDate($data['update_date'], "Y-m-d H:i:s")) {
            $l10n->setUpdateDate(new DateTime($data['update_date']));
        }

        return $l10n;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
