<?php namespace Stage\Post\Dossier\Sticker;

use DateTime;
use Exception;
use Stage\Helper;

class Dossier
{
    const STATE_SCHEDULE = 4;
    const STATE_ONLINE = 5;

    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idDossier;

    /**
     * @var
     */
    private $name;

    /**
     * @var
     */
    private $managementName;

    /**
     * @var
     */
    private $nameStripped;

    /**
     * @var
     */
    private $position;

    /**
     * @var
     */
    private $total;

    /**
     * @var
     */
    private $image;

    /**
     * @var
     */
    private $imageAlign;

    /**
     * @var
     */
    private $state;

    /**
     * @var
     */
    private $description;

    /**
     * @var
     */
    private $registerDate;

    /**
     * @var
     */
    private $beginDate;

    /**
     * @var
     */
    private $endDate;

    /**
     * @var
     */
    private $updateDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idDossier', 'name', 'managementName', 'nameStripped', 'position', 'total', 'image', 'imageAlign', 'state', 'description', 'registerDate', 'updateDate', 'beginDate', 'endDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = array();


    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model


    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = array();

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdDossier()
    {
        return $this->idDossier;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getManagementName()
    {
        return $this->managementName;
    }

    public function getNameStripped()
    {
        return $this->nameStripped;
    }

    public function getPosition()
    {
        return $this->position;
    }

    public function getTotal()
    {
        return $this->total;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getState()
    {
        return $this->state;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function getBeginDate()
    {
        return $this->beginDate;
    }

    public function getEndDate()
    {
        return $this->endDate;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    private function setId($id)
    {
        $this->id = (int)$id;
    }

    private function setIdDossier($idDossier)
    {
        $this->idDossier = (int)$idDossier;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setManagementName($name)
    {
        $this->managementName = $name;
    }

    public function setNameStripped($name)
    {
        $this->nameStripped = $name;
    }

    public function setPosition($position)
    {
        $this->position = (int)$position;
    }

    public function setTotal($total)
    {
        $this->total = (int)$total;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageAlign($imageAlign)
    {
        $this->imageAlign = $imageAlign;
    }

    public function setState($state)
    {
        $this->state = (int)$state;
    }

    public function setDescription($desc)
    {
        $this->description = $desc;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setBeginDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->beginDate = "";
        } else {
            //$date = new DateTime($date);
            $this->beginDate = $date->format(DateTime::ATOM);
        }
    }

    public function setEndDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->endDate = "";
        } else {
            //$date = new DateTime($date);
            $this->endDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson($options = 0)
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "name" || $attribute == "nameStripped") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    public function __clone()
    {
        trigger_error('Clone is not allowed.', E_USER_ERROR);
    }

    /**
     * createInstance
     *
     * @param $tag
     * @return Dossier
     * @throws Exception
     */
    public static function createInstance($tag)
    {
        $tagInstance = new static();
        $tagInstance->setId($tag['id_sticker']);
        $tagInstance->setIdDossier($tag['id_dossier']);
        $tagInstance->setName(html_entity_decode($tag['name'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setManagementName(html_entity_decode($tag['management_name'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setNameStripped($tag['name_stripped']);
        $tagInstance->setPosition(isset($tag['position']) ? (int)$tag['position'] : 0);
        $tagInstance->setTotal(isset($tag['total']) ? (int)$tag['total'] : 0);
        $tagInstance->setImage(isset($tag['image']) ? $tag['image'] : "");
        $tagInstance->setImageAlign(isset($tag['image_align']) ? $tag['image_align'] : "");
        $tagInstance->setState($tag['state']);
        $tagInstance->setDescription(html_entity_decode($tag['description'], ENT_COMPAT, 'UTF-8'));

        if (isset($tag['begin_date']) && Helper::isValidDate($tag['begin_date'], "Y-m-d H:i:s")) {
            $tagInstance->setBeginDate(new DateTime($tag['begin_date']));
        }

        if (isset($tag['end_date']) && Helper::isValidDate($tag['end_date'], "Y-m-d H:i:s")) {
            $tagInstance->setEndDate(new DateTime($tag['end_date']));
        }

        if (isset($tag['register_date']) && Helper::isValidDate($tag['register_date'], "Y-m-d H:i:s")) {
            $tagInstance->setRegisterDate(new DateTime($tag['register_date']));
        }

        if (isset($tag['update_date']) && Helper::isValidDate($tag['update_date'], "Y-m-d H:i:s")) {
            $tagInstance->setUpdateDate(new DateTime($tag['update_date']));
        }

        return $tagInstance;
    }
}
