<?php namespace Stage\Post\Dossier\Sticker;

use PDO;
use DateTime;
use Exception;
use Stage\Stage;
use Stage\Helper;
use Stage\Paginator;
use Stage\Post\MyArrayObject;

class Sticker
{

    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idGroup = -1;

    /**
     * @var
     */
    private $name;

    /**
     * @var
     */
    private $nameStripped;

    /**
     * @var
     */
    private $token;

    /**
     * @var
     */
    private $maximumItems;

    /**
     * @var
     */
    private $numberOfRows;

    /**
     * @var
     */
    private $displayIn;

    /**
     * @var
     */
    private $idFormat;

    /**
     * @var
     */
    private $link;

    /**
     * @var
     */
    private $autoFeed;

    /**
     * @var
     */
    private $autoFeedOrder;

    /**
     * @var
     */
    private $autoFeedType;

    /**
     * @var
     */
    private $color;

    /**
     * @var
     */
    private $active;

    /**
     * @var
     */
    private $position;

    /**
     * @var
     */
    private $total;

    /**
     * @var
     */
    private $state;

    /**
     * @var
     */
    private $image;

    /**
     * @var
     */
    private $imageAlign;

    /**
     * @var
     */
    private $imageWidth;

    /**
     * @var
     */
    private $imageHeight;

    /**
     * @var
     */
    private $idAsset;

    /**
     * @var
     */
    private $registerDate;

    /**
     * @var
     */
    private $beginDate;

    /**
     * @var
     */
    private $endDate;

    /**
     * @var
     */
    private $updateDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idGroup', 'name', 'nameStripped', 'token', 'image', 'imageAlign', 'imageWidth', 'imageHeight', 'idAsset', 'maximumItems', 'numberOfRows', 'displayIn', 'idFormat', 'link', 'autoFeed', 'autoFeedOrder', 'autoFeedType', 'color', 'active', 'position', 'total', 'state', 'registerDate', 'updateDate', 'beginDate', 'endDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = array();


    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model


    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = array();

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdGroup()
    {
        return $this->idGroup;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getNameStripped()
    {
        return $this->nameStripped;
    }

    public function getToken()
    {
        return $this->token;
    }

    public function getMaximumItems()
    {
        return $this->maximumItems;
    }

    public function getNumberOfRows()
    {
        return $this->numberOfRows;
    }

    public function getDisplayIn()
    {
        return $this->displayIn;
    }

    public function getIdFormat()
    {
        return $this->idFormat;
    }

    public function getLink()
    {
        return $this->link;
    }

    public function getAutoFeed()
    {
        return $this->autoFeed;
    }

    public function getAutoFeedOrder()
    {
        return $this->autoFeedOrder;
    }

    public function getAutoFeedType()
    {
        return $this->autoFeedType;
    }

    public function getColor()
    {
        return $this->color;
    }

    public function getActive()
    {
        return $this->active;
    }

    public function getPosition()
    {
        return $this->position;
    }

    public function getTotal()
    {
        return $this->total;
    }

    public function getState()
    {
        return $this->state;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getImageAlign()
    {
        return $this->imageAlign;
    }

    public function getImageWidth()
    {
        return $this->imageWidth;
    }

    public function getImageHeight()
    {
        return $this->imageHeight;
    }

    public function getIdAsset()
    {
        return $this->idAsset;
    }

    public function getBeginDate()
    {
        return $this->beginDate;
    }

    public function getEndDate()
    {
        return $this->endDate;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    private function setId($id)
    {
        $this->id = (int)$id;
    }

    public function setIdGroup($id)
    {
        $this->idGroup = (int)$id;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setNameStripped($name)
    {
        $this->nameStripped = $name;
    }

    public function setToken($token)
    {
        $this->token = $token;
    }

    public function setMaximumItems($total)
    {
        $this->maximumItems = $total;
    }

    public function setNumberOfRows($total)
    {
        $this->numberOfRows = $total;
    }

    public function setDisplayIn($in)
    {
        $this->displayIn = $in;
    }

    public function setIdFormat($idFormat)
    {
        $this->idFormat = $idFormat;
    }

    public function setLink($link)
    {
        $this->link = $link;
    }

    public function setAutoFeed($feed)
    {
        $this->autoFeed = $feed;
    }

    public function setAutoFeedOrder($order)
    {
        $this->autoFeedOrder = $order;
    }

    public function setAutoFeedType($type)
    {
        $this->autoFeedType = $type;
    }

    public function setColor($color)
    {
        $this->color = $color;
    }

    public function setActive($active)
    {
        $this->active = (bool)$active;
    }

    public function setPosition($position)
    {
        $this->position = (int)$position;
    }

    public function setTotal($total)
    {
        $this->total = (int)$total;
    }

    public function setState($state)
    {
        $this->state = $state;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageAlign($imageAlign)
    {
        $this->imageAlign = $imageAlign;
    }

    public function setImageWidth($imageWidth)
    {
        $this->imageWidth = (int)$imageWidth;
    }

    public function setImageHeight($height)
    {
        $this->imageHeight = (int)$height;
    }

    public function setIdAsset($id)
    {
        $this->idAsset = (int)$id;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setBeginDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->beginDate = "";
        } else {
            //$date = new DateTime($date);
            $this->beginDate = $date->format(DateTime::ATOM);
        }
    }

    public function setEndDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->endDate = "";
        } else {
            //$date = new DateTime($date);
            $this->endDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    /**
     * @param Query $q
     * @param bool $count
     * @return MyArrayObject
     * @throws Exception
     */
    public static function dossiers(Query $q, $count = false, $page = 1, $perPage = 15)
    {
        // table: dossiers_stickers_related
        // retorna dossiers com a position
        $field = $q->field;
        $query = $q->query;
        $filter = $q->filter;
        $limit_a = $q->from;
        $limit_b = $q->to;

        try {
            $method = "GET";
            if ($count == true) {
                $parameters = [[$q->field, PDO::PARAM_INT],
                    [$q->sndField, PDO::PARAM_INT],
                    [$q->trdField, PDO::PARAM_INT],
                    [$q->query, PDO::PARAM_STR],
                    [$q->filter, PDO::PARAM_STR],
                    [$q->sndFilter, PDO::PARAM_STR],
                    [$q->trdFilter, PDO::PARAM_STR]];

                $name = "POSTS_DOSSIERS_STICKERS_RELATED_COUNT";
                $data = Stage::esp($parameters, $name, $method);
                $total = isset($data[0]) && $data[0]['total'] ? (int)$data[0]['total'] : 0;

                // Create a new Paginator
                $p = new Paginator($total, $perPage);
                $p->page($page);
                $q->from = $p->from();
                $q->to = $p->to();
            }

            $limit_a = isset($p) ? $p->from() : $q->from;
            $limit_b = isset($p) ? $p->to() : $q->to;

            $parameters = [[$q->field, PDO::PARAM_INT],
                [$q->sndField, PDO::PARAM_INT],
                [$q->trdField, PDO::PARAM_INT],
                [$q->query, PDO::PARAM_STR],
                [$q->filter, PDO::PARAM_STR],
                [$q->sndFilter, PDO::PARAM_STR],
                [$q->trdFilter, PDO::PARAM_STR],
                [$q->order, PDO::PARAM_INT],
                [$q->orderBy, PDO::PARAM_INT],
                [$limit_a, PDO::PARAM_INT],
                [$limit_b, PDO::PARAM_INT]];

            $name = "POSTS_DOSSIERS_STICKERS_RELATED";

            $data = Stage::esp($parameters, $name, $method);
            if (isset($data[0]) && isset($data[0]['id_sticker'])) {
                $result = new MyArrayObject(array_map(function ($post) {
                    return Dossier::createInstance($post);
                }, $data));

                if (isset($p)) {
                    $result->setCount($total);
                    $result->setPaginator($p);
                }

                return $result;
            } else {
                $result = new MyArrayObject([]);
                if (isset($p)) {
                    $result->setCount($total);
                    $result->setPaginator($p);
                }
                return $result;
            }

        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson($options = 0)
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "name" || $attribute == "nameStripped") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    public function __clone()
    {
        trigger_error('Clone is not allowed.', E_USER_ERROR);
    }

    /**
     * createInstance
     *
     * @param $data
     */
    public static function createInstance($tag)
    {
        $tagInstance = new static();
        $tagInstance->setId($tag['id_sticker']);
        $tagInstance->setIdGroup($tag['id_group']);
        $tagInstance->setName(html_entity_decode($tag['name'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setNameStripped($tag['name_stripped']);
        $tagInstance->setToken($tag['token']);
        $tagInstance->setImage(isset($tag['image']) ? $tag['image'] : "");
        $tagInstance->setImageAlign(isset($tag['image_align']) ? $tag['image_align'] : "");
        $tagInstance->setImageWidth($tag['image_width']);
        $tagInstance->setImageHeight($tag['image_height']);
        $tagInstance->setIdAsset($tag['id_asset']);
        $tagInstance->setMaximumItems($tag['maximum_items']);
        $tagInstance->setNumberOfRows($tag['number_of_rows']);
        $tagInstance->setDisplayIn($tag['display_in']);
        $tagInstance->setIdFormat($tag['id_format']);
        $tagInstance->setLink($tag['link']);
        $tagInstance->setAutoFeed($tag['auto_feed']);
        $tagInstance->setAutoFeedOrder($tag['auto_feed_order']);
        $tagInstance->setAutoFeedType($tag['auto_feed_type']);
        $tagInstance->setColor($tag['color']);
        $tagInstance->setActive($tag['active']);
        $tagInstance->setPosition(isset($tag['position']) ? (int)$tag['position'] : 0);
        $tagInstance->setTotal(isset($tag['total']) ? (int)$tag['total'] : 0);
        $tagInstance->setState($tag['state']);

        if (isset($tag['register_date']) && Helper::isValidDate($tag['register_date'], "Y-m-d H:i:s")) {
            $tagInstance->setRegisterDate(new DateTime($tag['register_date']));
        }

        if (isset($tag['update_date']) && Helper::isValidDate($tag['update_date'], "Y-m-d H:i:s")) {
            $tagInstance->setUpdateDate(new DateTime($tag['update_date']));
        }

        return $tagInstance;
    }
}
