<?php namespace Stage\Post\L10n;

class ImageOption
{
    /**
     * @var
     */
    private $ratio = "";

    /**
     * @var
     */
    private $imageAlign;

    /**
     * @var
     */
    private $imageOptimization;

    /**
     * @var
     */
    private $settings;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('ratio', 'imageAlign', 'imageOptimization', 'settings');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    public function getRatio()
    {
        return $this->ratio;
    }

    public function getImageAlign()
    {
        return $this->imageAlign;
    }

    public function getImageOptimization()
    {
        return $this->imageOptimization;
    }

    private function setRatio($ratio)
    {
        $this->ratio = $ratio;
    }

    public function setImageAlign($align)
    {
        $this->imageAlign = $align;
    }

    public function setImageOptimization($optimization)
    {
        $this->imageOptimization = $optimization;
    }

    public function setSettings($settings)
    {
        $this->settings = $settings;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $this->$attribute;
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return ImageOption
     */
    public static function createInstance($data)
    {
        $body = new self();
        $body->setRatio($data['ratio']);
        $body->setImageAlign($data['image_align']);
        $body->setImageOptimization($data['image_optimization']);
        $body->setSettings($data['settings']);
        return $body;
    }

    public function __toString()
    {
        return "My id is: {$this->getRatio()}\n";
    }
}
