<?php namespace Stage\Post\L10n\Key;

use DateTime;
use Stage\Helper;

class Variant
{
    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idL10n;

    /**
     * @var
     */
    private $idKey;

    /**
     * @var
     */
    private $name;

    /**
     * @var
     */
    private $nameStripped;

    /**
     * @var
     */
    private $headline;

    /**
     * @var
     */
    private $title;

    /**
     * @var
     */
    private $description;

    /**
     * @var
     */
    private $image;

    /**
     * @var
     */
    private $imageAlign = "";

    /**
     * @var
     */
    private $idAsset = 0;

    /**
     * @var
     */
    private $imageWidth = 0;

    /**
     * @var
     */
    private $imageHeight = 0;

    /**
     * @var
     */
    private $metaTitle = "";

    /**
     * @var
     */
    private $metaDescription = "";

    /**
     * @var
     */
    private $metaImage = "";

    /**
     * @var
     */
    private $imageTitle = "";

    /**
     * @var
     */
    private $imageAlterText = "";

    /**
     * @var
     */
    private $metaKeywords = "";

    /**
     * @var
     */
    private $metaPlayMark = "";

    /**
     * @var
     */
    private $position = 0;

    /**
     * @var
     */
    private $registerDate;

    /**
     * @var
     */
    private $updateDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idL10n', 'idKey', 'name', 'nameStripped', 'headline', 'title', 'description', 'image', 'imageAlign', 'idAsset', 'imageWidth', 'imageHeight', 'metaTitle', 'metaDescription', 'metaImage', 'imageTitle', 'imageAlterText', 'metaKeywords', 'metaPlayMark', 'position', 'registerDate', 'updateDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdL10n()
    {
        return $this->idL10n;
    }

    public function getIdKey()
    {
        return $this->idKey;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getNameStripped()
    {
        return $this->nameStripped;
    }

    public function getHeadline()
    {
        return $this->headline;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getImageAlign()
    {
        return $this->imageAlign;
    }

    public function getIdAsset()
    {
        return $this->idAsset;
    }

    public function getImageWidth()
    {
        return $this->imageWidth;
    }

    public function getImageHeight()
    {
        return $this->imageHeight;
    }

    public function getMetaTitle()
    {
        return $this->metaTitle;
    }

    public function getMetaDescription()
    {
        return $this->metaDescription;
    }

    public function getMetaImage()
    {
        return $this->metaImage;
    }

    public function getImageTitle()
    {
        return $this->imageTitle;
    }

    public function getImageAlterText()
    {
        return $this->imageAlterText;
    }

    public function getMetaKeywords()
    {
        return $this->metaKeywords;
    }

    public function getMetaPlayMark()
    {
        return $this->metaPlayMark;
    }

    public function getPosition()
    {
        return $this->position;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    private function setId($id)
    {
        $this->id = (int)$id;
    }

    private function setIdL10n($id)
    {
        $this->idL10n = (int)$id;
    }

    private function setIdKey($id)
    {
        $this->idKey = (int)$id;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setNameStripped($name)
    {
        $this->nameStripped = $name;
    }

    public function setHeadline($name)
    {
        $this->headline = $name;
    }

    public function setTitle($name)
    {
        $this->title = $name;
    }

    public function setDescription($name)
    {
        $this->description = $name;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageAlign($val)
    {
        $this->imageAlign = $val;
    }

    public function setIdAsset($val)
    {
        $this->idAsset = $val;
    }

    public function setImageWidth($width)
    {
        $this->imageWidth = $width;
    }

    public function setImageHeight($height)
    {
        $this->imageHeight = $height;
    }

    public function setMetaTitle($title)
    {
        $this->metaTitle = $title;
    }

    public function setMetaDescription($desc)
    {
        $this->metaDescription = $desc;
    }

    public function setMetaImage($image)
    {
        $this->metaImage = $image;
    }

    public function setImageTitle($title)
    {
        $this->imageTitle = $title;
    }

    public function setImageAlterText($title)
    {
        $this->imageAlterText = $title;
    }

    public function setMetaKeywords($metaKeywords)
    {
        $this->metaKeywords = $metaKeywords;
    }

    public function setMetaPlayMark($playMark)
    {
        $this->metaPlayMark = (bool)$playMark;
    }

    public function setPosition($position)
    {
        $this->position = (int)$position;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "name" || $attribute == "nameStripped" || $attribute == "title" || $attribute == "headline" || $attribute == "description" || $attribute == "metaTitle" || $attribute == "metaDescription") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    /**
     * createInstance
     *
     * @param $data
     */
    public static function createInstance($tag)
    {
        $tagInstance = new self();
        $tagInstance->setId($tag['id_variant']);
        $tagInstance->setIdL10n($tag['id_l10n']);
        $tagInstance->setIdKey($tag['id_key']);
        $tagInstance->setName(html_entity_decode($tag['name'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setNameStripped($tag['name_stripped']);
        $tagInstance->setHeadline(html_entity_decode($tag['headline'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setTitle(html_entity_decode($tag['title'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setDescription(html_entity_decode($tag['description'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setImage($tag['image']);
        $tagInstance->setImageAlign($tag['image_align']);
        $tagInstance->setIdAsset($tag['id_asset']);
        $tagInstance->setImageWidth($tag['image_width']);
        $tagInstance->setImageHeight($tag['image_height']);
        $tagInstance->setMetaTitle(html_entity_decode($tag['meta_title'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setMetaDescription(html_entity_decode($tag['meta_description'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setMetaImage($tag['meta_image']);
        $tagInstance->setImageTitle($tag['image_title']);
        $tagInstance->setImageAlterText($tag['image_alter_text']);
        $tagInstance->setMetaKeywords($tag['meta_keywords']);
        $tagInstance->setMetaPlayMark($tag['meta_play_mark']);
        $tagInstance->setPosition($tag['position']);

        if (isset($tag['register_date']) && Helper::isValidDate($tag['register_date'], "Y-m-d H:i:s")) {
            $tagInstance->setRegisterDate(new DateTime($tag['register_date']));
        }

        if (isset($tag['update_date']) && Helper::isValidDate($tag['update_date'], "Y-m-d H:i:s")) {
            $tagInstance->setUpdateDate(new DateTime($tag['update_date']));
        }

        return $tagInstance;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
