<?php namespace Stage\Post\Sticker\MenuItem;

use PDO;
use DateTime;
use Exception;
use Stage\Stage;
use Stage\Helper;
use Stage\Post\MyArrayObject;

class Item
{
    const CREATE = 0;
    const ROOT = 1;

    const TYPE_DOSSIER = 1;
    const TYPE_COLLECTION = 2;
    const TYPE_TAG = 3;
    const TYPE_LINK = 4;
    const TYPE_PLACEHOLDER = 5;

    public static $instanceCounter = 0;

    /**
     * @var
     */
    private $idSticker;

    /**
     * @var
     */
    private $idItem = -1;

    /**
     * @var
     */
    private $parentIdItem;

    /**
     * @var
     */
    private $name;

    /**
     * @var
     */
    private $description;

    /**
     * @var
     */
    private $itemType;

    /**
     * @var
     */
    private $itemAction;

    /**
     * @var
     */
    private $itemValue;

    /**
     * @var
     */
    private $image;

    /**
     * @var
     */
    private $color;

    /**
     * @var
     */
    private $trackingParameters;

    /**
     * @var
     */
    private $position;

    /**
     * @var
     */
    private $slug;

    /**
     * @var
     */
    private $registerDate;

    /**
     * @var
     */
    private $beginDate;

    /**
     * @var
     */
    private $endDate;

    /**
     * @var
     */
    private $updateDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('idSticker', 'idItem', 'parentIdItem', 'name', 'description', 'itemType', 'itemAction', 'itemValue', 'image', 'color', 'trackingParameters', 'position', 'slug', 'registerDate', 'updateDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = array();


    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model


    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = array();

    public function __construct()
    {
        self::$instanceCounter++;
    }

    public function getIdSticker()
    {
        return $this->idSticker;
    }

    public function getIdItem()
    {
        return $this->idItem;
    }

    public function getParentIdItem()
    {
        return $this->parentIdItem;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function getItemType()
    {
        return $this->itemType;
    }

    public function getItemAction()
    {
        return $this->itemAction;
    }

    public function getItemValue()
    {
        return $this->itemValue;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getColor()
    {
        return $this->color;
    }

    public function getTrackingParameters()
    {
        return $this->trackingParameters;
    }

    public function getPosition()
    {
        return $this->position;
    }

    public function getSlug()
    {
        return $this->slug;
    }

    public function getBeginDate()
    {
        return $this->beginDate;
    }

    public function getEndDate()
    {
        return $this->endDate;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    public function setIdSticker($id)
    {
        $this->idSticker = (int)$id;
    }

    public function setIdItem($id)
    {
        $this->idItem = (int)$id;
    }

    public function setParentIdItem($id)
    {
        $this->parentIdItem = (int)$id;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setDescription($name)
    {
        $this->description = $name;
    }

    public function setItemType($type)
    {
        $this->itemType = $type;
    }

    public function setItemAction($action)
    {
        $this->itemAction = $action;
    }

    public function setItemValue($value)
    {
        $this->itemValue = $value;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setColor($color)
    {
        $this->color = $color;
    }

    public function setTrackingParameters($parameters)
    {
        $this->trackingParameters = $parameters;
    }

    public function setPosition($position)
    {
        $this->position = (int)$position;
    }

    public function setSlug($slug)
    {
        $this->slug = $slug;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setBeginDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->beginDate = "";
        } else {
            //$date = new DateTime($date);
            $this->beginDate = $date->format(DateTime::ATOM);
        }
    }

    public function setEndDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->endDate = "";
        } else {
            //$date = new DateTime($date);
            $this->endDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    /**
     * save
     *
     * Save an item
     *
     * @param $parentIdItem
     * @return $this
     * @throws Exception
     */
    public function save($parentIdItem)
    {
        // table: posts_stickers_menu_itens
        try {
            $name = "POSTS_STICKERS_MENU_ITEMS";
            $method = "SET";
            $parameters = [[$this->getIdSticker(), PDO::PARAM_INT],
                [$this->getIdItem(), PDO::PARAM_INT],
                [$parentIdItem, PDO::PARAM_INT],
                [$this->getName(), PDO::PARAM_STR],
                [$this->getDescription(), PDO::PARAM_STR],
                [$this->getItemType(), PDO::PARAM_INT],
                [$this->getItemAction(), PDO::PARAM_INT],
                [$this->getItemValue(), PDO::PARAM_STR],
                [$this->getImage(), PDO::PARAM_STR],
                [$this->getColor(), PDO::PARAM_STR],
                [$this->getTrackingParameters(), PDO::PARAM_STR],
                [$this->getPosition(), PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            if (isset($data[0]) && isset($data[0]['id_sticker'])) {
                $this->setIdSticker($data[0]['id_sticker']);
                $this->setIdItem($data[0]['id_item']);
                $this->setParentIdItem($parentIdItem);
                if (isset($data[0]) && isset($data[0]['register_date']) && Helper::isValidDate($data[0]['register_date'], "Y-m-d H:i:s")) {
                    $this->setRegisterDate(new DateTime($data[0]['register_date']));
                }

                if (isset($data[0]) && isset($data[0]['update_date']) && Helper::isValidDate($data[0]['update_date'], "Y-m-d H:i:s")) {
                    $this->setUpdateDate(new DateTime($data[0]['update_date']));
                }
                return $this;
            } else {
                throw new Exception("Error saving Item", $data[0]['return_code']);
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Find an Item
     *
     * @param $idSticker
     * @param $idItem
     * @param int $toLevel The subdirectory return deep level
     * @return MyArrayObject
     * @throws Exception
     */
    public static function find($idSticker, $idItem, $toLevel = 10000)
    {
        // http://stackoverflow.com/questions/8656089/solution-for-fatal-error-maximum-function-nesting-level-of-100-reached-abor
        if (self::$instanceCounter > $toLevel) {
            return 1;
        }

        try {
            $name = "POSTS_STICKERS_MENU_ITEM";
            $method = "GET";
            $parameters = [[$idSticker, PDO::PARAM_INT],
                [$idItem, PDO::PARAM_INT]];
            $data = Stage::esp($parameters, $name, $method);
            if (isset($data[0]['return_code']) && ($data[0]['return_code']) == "-2") {
                throw new Exception("The Sticker id $idSticker and Item $idItem not exists.", $data[0]['return_code']);
            } elseif (isset($data[0]['id_item'])) {
                $ret = new \Stage\Post\MyArrayObject(array_map(function ($directory) {
                    return self::createInstance($directory);
                }, $data));
                $ret->setCount(1);
                return $ret;
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * all
     *
     * @param $idSticker
     * @param bool|false $raw If $raw is true then return the data directly from the SP
     * @return array
     * @throws Exception
     */
    public static function all($idSticker, $raw = false)
    {
        try {
            $name = "POSTS_STICKERS_MENU_ITEMS";
            $method = "GET";
            $parameters = [
                [$idSticker, PDO::PARAM_INT]
            ];
            $directories = Stage::esp($parameters, $name, $method);
            return !$raw ? array_map(function ($directory) {
                return self::createInstance($directory);
            }, $directories) : $directories;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * appendTo
     *
     * @param $parentIdItem
     * @return $this
     * @throws Exception
     */
    public function appendTo($parentIdItem = 0)
    {
        try {
            return $this->save($parentIdItem);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * build
     *
     * Build the tree array of directories
     *
     * @param $idSticker
     * @return array
     * @throws Exception
     * @url http://stackoverflow.com/questions/4452472/category-hierarchy-php-mysql
     */
    public static function build($idSticker)
    {
        $directories = self::all($idSticker, true);
        $rootId = 1;
        $refs = array();
        $list = array();
        foreach ($directories as $row) {
            $ref = &$refs[$row['id_item']];

            $ref['id'] = (int)$row['id_item'];
            $ref['parentId'] = (int)$row['parent_id_item'];
            $ref['name'] = html_entity_decode($row['name'], ENT_COMPAT, 'UTF-8');
            $ref['description'] = html_entity_decode($row['description'], ENT_COMPAT, 'UTF-8');
            $ref['itemType'] = $row['item_type'];
            $ref['itemAction'] = $row['item_action'];
            $ref['itemValue'] = $row['item_value'];
            $ref['image'] = $row['image'];
            $ref['color'] = $row['color'];
            $ref['trackingParameters'] = $row['tracking_parameters'];
            $ref['position'] = $row['position'];
            $ref['total'] = $row['total'];
            if ($row['item_type'] == self::TYPE_TAG) {
                $ref['slug'] = html_entity_decode($row['slug'], ENT_COMPAT, 'UTF-8');
            } else {
                $ref['slug'] = (object)['l10n' => $row['slug'] == "" ? [] : self::slugToL10n(html_entity_decode($row['slug'], ENT_COMPAT, 'UTF-8'))];
            }

            if ($row['parent_id_item'] == $rootId) {
                //$list[$row['id_directory']] = & $ref; // Put this if you want the array keys has directory id
                $list[] = &$ref;
            } else {
                // $refs[$row['parent_id_directory']]['children'][$row['id_directory']] = & $ref;   // Put this if you want the array keys has directory id
                $refs[$row['parent_id_item']]['children'][] = &$ref;
            }
        }

        return $list;
    }

    /**
     * findNode
     *
     * Find the node of some directory id
     * @param $tree
     * @param $idItem
     * @return array
     */
    public static function findNode($tree, $idItem)
    {
        $temp = [];
        foreach ($tree as $node) {
            if ($node['id'] == $idItem) {
                return $node;
            } elseif (isset($node['children'])) {
                $temp = self::findNode($node['children'], $idItem);
                if ($temp) {
                    return $temp;
                }
            }
        }

        return $temp;
    }

    /**
     * children
     *
     * @param $tree The parameter $tree must start with index 0
     * @return array
     */
    public static function children(array $tree)
    {
        $result = [];
        $ids = [];
        foreach ($tree as $object) {
            $ids = self::findIds($object, array());
            $result[] = array('id' => $object['id'], 'children' => $ids);
        }

        return sizeof($result) ? $result[0] : $result;
    }

    /**
     * findIds
     *
     * This is an helper method
     * @param $child
     * @param $ids
     * @return array
     * @see http://stackoverflow.com/questions/33800847/get-all-children-of-a-nested-tree-recursively
     */
    private static function findIds($child, $ids)
    {
        if (isset($child['children'])) {
            if (count($child['children']) > 0) {
                foreach ($child['children'] as $ch) {
                    $ids[] = ['id' => $ch['id'],
                        'name' => $ch['name'],
                        'description' => $ch['description'],
                        'link' => $ch['link'],
                        'parentId' => $ch['parentId']];

                    $ids = self::findIds($ch, $ids);
                }
            }
        }

        return $ids;
    }

    /**
     * delete
     *
     * Delete an Item
     *
     * @param $idSticker
     * @param $idItem
     * @param bool $softDelete
     * @param bool $deleted
     * @return bool
     * @throws Exception
     */
    public static function delete($idSticker, $idItem, $softDelete = true, $deleted = true)
    {
        if ($softDelete) {
            $name = "POSTS_STICKERS_MENU_ITEM_DELETED";
            $parameters = [
                [$idSticker, PDO::PARAM_INT],
                [$idItem, PDO::PARAM_INT],
                [$deleted, PDO::PARAM_BOOL]
            ];
            $method = "SET";
        } else {
            $name = "POSTS_STICKERS_MENU_ITEM";
            $parameters = [
                [$idSticker, PDO::PARAM_INT],
                [$idItem, PDO::PARAM_INT]
            ];
            $method = "DEL";
        }

        try {
            $data = Stage::esp($parameters, $name, $method);
            if (isset($data[0]['return_code']) && $data[0]['return_code'] == "-2") {
                throw new Exception("The Sticker id $idSticker and/or Item $idItem not exists in database", $data[0]['return_code']);
            }
            return isset($data[0]) && isset($data[0]['return_code']) && $data[0]['return_code'] == "0";
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * markedToDelete
     *
     * @return array
     * @throws Exception
     */
    public static function markedToDelete($idSticker)
    {
        try {
            $parameters = [
                [$idSticker, PDO::PARAM_INT],
            ];
            $name = "POSTS_STICKERS_MENU_ITEMS_DELETED";
            $method = "GET";
            $directories = Stage::esp($parameters, $name, $method);

            return array_map(function ($directory) {
                return self::createInstance($directory);
            }, $directories);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson($options = 0)
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "name" || $attribute == "nameStripped") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    public function __clone()
    {
        trigger_error('Clone is not allowed.', E_USER_ERROR);
    }

    public static function slugify($text, $divider = '-')
    {
        // replace non letter or digits by divider
        $text = preg_replace('~[^\pL\d]+~u', $divider, $text);

        // transliterate
        $text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);

        // remove unwanted characters
        $text = preg_replace('~[^-\w]+~', '', $text);

        // trim
        $text = trim($text, $divider);

        // remove duplicate divider
        $text = preg_replace('~-+~', $divider, $text);

        // lowercase
        $text = strtolower($text);

        if (empty($text)) {
            return 'n-a';
        }

        return $text;
    }

    private static function slugToL10n($slug)
    {
        $p1 = explode("|", $slug);
        $data = [];
        foreach ($p1 as $p) {
            $explode = explode(".", $p);
            $tmp['isoLanguage'] = $explode[0];
            $tmp['slug'] = self::slugify($explode[1]);
            $data[] = (object)$tmp;
        }
        return $data;
    }

    /**
     * createInstance
     *
     * @param $data
     */
    public static function createInstance($tag)
    {
        $tagInstance = new static();
        $tagInstance->setIdSticker($tag['id_sticker']);
        $tagInstance->setIdItem($tag['id_item']);
        $tagInstance->setParentIdItem($tag['parent_id_item']);
        $tagInstance->setName(html_entity_decode($tag['name'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setDescription(html_entity_decode($tag['description'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setItemType($tag['item_type']); // 1 - Dossier | 2 - Collection | 3 - Tag | 4 - Link | 5 - placeholder
        $tagInstance->setItemAction($tag['item_action']);
        $tagInstance->setItemValue($tag['item_value']);
        $tagInstance->setImage(isset($tag['image']) ? $tag['image'] : "");
        $tagInstance->setColor($tag['color']);
        $tagInstance->setTrackingParameters($tag['tracking_parameters']);
        $tagInstance->setPosition(isset($tag['position']) ? (int)$tag['position'] : 0);

        if ($tag['item_type'] == self::TYPE_TAG) {
            $slug = "";
        } else {
            $slug = (object)['l10n' => $tag['slug'] == "" ? [] : self::slugToL10n($tag['slug'])];
        }

        $tagInstance->setSlug($slug);

        if (isset($tag['register_date']) && Helper::isValidDate($tag['register_date'], "Y-m-d H:i:s")) {
            $tagInstance->setRegisterDate(new DateTime($tag['register_date']));
        }

        if (isset($tag['update_date']) && Helper::isValidDate($tag['update_date'], "Y-m-d H:i:s")) {
            $tagInstance->setUpdateDate(new DateTime($tag['update_date']));
        }

        return $tagInstance;
    }
}
