<?php namespace Stage\Post\Sticker;

use DateTime;
use Stage\Helper;

class Post
{

    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idPost;

    /**
     * @var
     */
    private $name;

    /**
     * @var
     */
    private $nameStripped;

    /**
     * @var
     */
    private $position;

    /**
     * @var
     */
    private $total;

    /**
     * @var
     */
    private $image;

    /**
     * @var
     */
    private $state;

    /**
     * @var
     */
    private $title;

    /**
     * @var
     */
    private $description;

    /**
     * @var
     */
    private $fixed;

    /**
     * @var
     */
    private $value;

    /**
     * @var
     */
    private $registerDate;

    /**
     * @var
     */
    private $beginDate;

    /**
     * @var
     */
    private $endDate;

    /**
     * @var
     */
    private $updateDate;

    /**
     * @var
     */
    private $publishDate;

    /**
     * @var
     */
    private $postBeginDate;

    /**
     * @var
     */
    private $postEndDate;

    /**
     * @var
     */
    private $lastMessageAt;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idPost', 'name', 'nameStripped', 'position', 'total', 'image', 'state', 'title', 'description', 'fixed', 'value', 'registerDate', 'updateDate', 'beginDate', 'endDate', 'publishDate', 'postBeginDate', 'postEndDate', 'lastMessageAt');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = array();


    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model


    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = array();

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdPost()
    {
        return $this->idPost;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getNameStripped()
    {
        return $this->nameStripped;
    }

    public function getPosition()
    {
        return $this->position;
    }

    public function getTotal()
    {
        return $this->total;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getState()
    {
        return $this->state;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function isFixed()
    {
        return (bool) $this->fixed;
    }

    public function getValue()
    {
        return $this->value;
    }

    public function getBeginDate()
    {
        return $this->beginDate;
    }

    public function getEndDate()
    {
        return $this->endDate;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    public function getPublishDate()
    {
        return $this->publishDate;
    }

    public function getPostBeginDate()
    {
        return $this->postBeginDate;
    }

    public function getPostEndDate()
    {
        return $this->postEndDate;
    }

    public function getLastMessageAt()
    {
        return $this->lastMessageAt;
    }

    private function setId($id)
    {
        $this->id = (int)$id;
    }

    private function setIdPost($id)
    {
        $this->idPost = (int)$id;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setNameStripped($name)
    {
        $this->nameStripped = $name;
    }

    public function setPosition($position)
    {
        $this->position = (int)$position;
    }

    public function setTotal($total)
    {
        $this->total = (int)$total;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setState($state)
    {
        $this->state = (int)$state;
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function setDescription($desc)
    {
        $this->description = $desc;
    }

    public function setIsFixed($is)
    {
        $this->fixed = (bool)$is;
    }

    public function setValue($val)
    {
        $this->value = $val;
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setBeginDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->beginDate = "";
        } else {
            //$date = new DateTime($date);
            $this->beginDate = $date->format(DateTime::ATOM);
        }
    }

    public function setEndDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->endDate = "";
        } else {
            //$date = new DateTime($date);
            $this->endDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    public function setPublishDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->publishDate = "";
        } else {
            //$date = new DateTime($date);
            $this->publishDate = $date->format(DateTime::ATOM);
        }
    }

    public function setPostBeginDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->postBeginDate = "";
        } else {
            //$date = new DateTime($date);
            $this->postBeginDate = $date->format(DateTime::ATOM);
        }
    }

    public function setPostEndDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->postEndDate = "";
        } else {
            //$date = new DateTime($date);
            $this->postEndDate = $date->format(DateTime::ATOM);
        }
    }

    public function setLastMessageAt($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->lastMessageAt = "";
        } else {
            //$date = new DateTime($date);
            $this->lastMessageAt = $date->format(DateTime::ATOM);
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson($options = 0)
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "name" || $attribute == "nameStripped") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "publishDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "postBeginDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "postEndDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "lastMessageAt" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    public function __clone()
    {
        trigger_error('Clone is not allowed.', E_USER_ERROR);
    }

    /**
     * createInstance
     *
     * @param $data
     */
    public static function createInstance($tag)
    {
        $tagInstance = new static();
        $tagInstance->setId($tag['id_sticker']);
        $tagInstance->setIdPost($tag['id_post']);
        $tagInstance->setName(html_entity_decode($tag['name'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setNameStripped($tag['name_stripped']);
        $tagInstance->setPosition(isset($tag['position']) ? (int)$tag['position'] : 0);
        $tagInstance->setTotal(isset($tag['total']) ? (int)$tag['total'] : 0);
        $tagInstance->setImage(isset($tag['image']) ? $tag['image'] : "");
        $tagInstance->setState($tag['state']);
        $tagInstance->setTitle(html_entity_decode($tag['title'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setDescription(html_entity_decode($tag['description'], ENT_COMPAT, 'UTF-8'));
        $tagInstance->setIsFixed(isset($tag['fixed']) ? $tag['fixed'] : false);
        $tagInstance->setValue(isset($tag['value']) ? $tag['value'] : -1); // It's the value associated with the position

        $datesMap = [
            'begin_date' => 'setBeginDate',
            'end_date' => 'setEndDate',
            'register_date' => 'setRegisterDate',
            'update_date' => 'setUpdateDate',
            'publish_date' => 'setPublishDate',
            'post_begin_date' => 'setPostBeginDate',
            'post_end_date' => 'setPostEndDate',
            'last_message_at' => 'setLastMessageAt',
        ];

        foreach ($datesMap as $key => $func){
            if (isset($tag[$key]) && Helper::isValidDate($tag[$key], "Y-m-d H:i:s")) {
                $tagInstance->$func(new DateTime($tag[$key]));
            }
        }

        return $tagInstance;
    }
}
