<?php namespace Stage;

class Service
{
    const ACCOUNTS  = 1;
    const POSTS     = 2;
    const LEADS     = 3;
    const ASSETS    = 4;
    const ARCHIVE   = 5;
    const VIDEO     = 6;
    const LIVE      = 7;
    const ADS       = 8;
    const PLAYERS   = 9;
    const ANALYTICS = 10;
    const SUPPORT   = 20;

    private static $services = [
        self::ACCOUNTS  => 'accounts',
        self::POSTS     => 'posts',
        self::LEADS     => 'leads',
        self::ASSETS    => 'assets',
        self::ARCHIVE   => 'archive',
        self::VIDEO     => 'video',
        self::LIVE      => 'live',
        self::ANALYTICS => 'analytics',
        self::PLAYERS   => 'players',
        self::ADS       => 'ads',
        self::SUPPORT   => 'support'
    ];

    public function __construct()
    {
    }

    /**
     * name
     *
     * @param $d
     * @return mixed|null
     */
    public static function name($d)
    {
        return self::$services[$d] ? self::$services[$d] : null;
    }

    /**
     * id
     * Converts a service to id
     * @param $idService
     * @return mixed|null
     */
    public static function id($service)
    {
        $exist = array_keys(array_filter(self::$services, function ($s) use ($service) {
            return $s == $service;
        }));

        return $exist ? $exist[0] : null;
    }
}
