<?php namespace Stage\Sprite;

use PDO;
use Exception;
use Stage\Stage;

class Sprite
{

    /**
     * @var
     */
    private $idAccount;

    /**
     * @var
     */
    private $accountToken;

    /**
     * @var
     */
    private $idVideo;

    /**
     * @var
     */
    private $video;

    /**
     * @var
     */
    private $spritew;

    /**
     * @var
     */
    private $spritespan;

    /**
     * @var
     */
    private $spritecol;

    /**
     * @var
     */
    private $with;

    /**
     * @var
     */
    private $height;

    /**
     * @var
     */
    private $seconds;

    /**
     * @var
     */
    private $aspecRatio;

    public function getIdAccount()
    {
        return $this->idAccount;
    }

    public function getAccountToken()
    {
        return $this->accountToken;
    }

    public function getIdVideo()
    {
        return $this->idVideo;
    }

    public function getVideo()
    {
        return $this->video;
    }

    public function getSpriteW()
    {
        return $this->spritew;
    }

    public function getSpriteSpan()
    {
        return $this->spritespan;
    }

    public function getSpriteCol()
    {
        return $this->spritecol;
    }

    public function getWith()
    {
        return $this->with;
    }

    public function getHeight()
    {
        return $this->height;
    }

    public function getSeconds()
    {
        return $this->seconds;
    }

    public function getAspecRatio()
    {
        return $this->aspecRatio;
    }

    public function setIdAccount($idAccount)
    {
        return $this->idAccount = $idAccount;
    }

    public function setAccountToken($accountToken)
    {
        return $this->accountToken = $accountToken;
    }

    public function setIdVideo($idVideo)
    {
        return $this->idVideo = $idVideo;
    }

    public function setVideo($video)
    {
        return $this->video = $video;
    }

    public function setSpritew($spritew)
    {
        return $this->spritew = $spritew;
    }

    public function setSpriteSpan($span)
    {
        return $this->spritespan = $span;
    }

    public function setSpriteCol($col)
    {
        return $this->spritecol = $col;
    }

    public function setWith($with)
    {
        return $this->with = $with;
    }

    public function setHeight($height)
    {
        return $this->height = $height;
    }

    public function setSeconds($seconds)
    {
        return $this->seconds = $seconds;
    }

    public function setAspecRatio($aspecRatio)
    {
        return $this->aspecRatio = $aspecRatio;
    }

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id','idAccount','accountToken', 'idVideo', 'spritew', 'spritespan', 'spritecol','width','height','seconds','aspectRatio');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    /**
     * save
     *
     * @return $this
     * @throws Exception
     */
    public function save()
    {
        try {
            // Write on table video_sprite_images_queue
            $name = "VIDEO_SPRITE";
            $method = "SET";
            $parameters = [[$this->getIdAccount(), PDO::PARAM_INT],
                           [$this->getAccountToken(), PDO::PARAM_STR],
                           [$this->getIdVideo(), PDO::PARAM_INT],
                           [$this->getVideo(), PDO::PARAM_STR],
                           [$this->getSpriteW(), PDO::PARAM_STR],
                           [$this->getSpriteSpan(), PDO::PARAM_STR],
                           [$this->getSpriteCol(), PDO::PARAM_STR],
                           [$this->getWith(), PDO::PARAM_INT],
                           [$this->getHeight(), PDO::PARAM_INT],
                           [$this->getSeconds(), PDO::PARAM_INT],
                           [$this->getAspecRatio(), PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);

            if (!sizeof($data)) {
                throw new Exception("Error saving sprite to queue.");
            } else {
                return $data;
            }
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * next
     *
     * Get the next in queue
     *
     * @param int $field
     * @return mixed|Job
     * @throws Exception
     */
    public static function next($field = 0, $machine = "")
    {
        try {
            $name = "VIDEO_SPRITE_TO_PROCESS";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                           [$machine, PDO::PARAM_STR]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : Job::createInstance($data[0]);
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * done
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function done($idQueue, $field = 1)
    {
        try {
            $name = "VIDEO_SPRITE_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * retry
     *
     * @param $idQueue
     * @param int $field
     * @return array
     * @throws Exception
     */
    public static function retry($idQueue, $field = 1)
    {
        try {
            $name = "VIDEO_SPRITE_NOT_PROCESSED";
            $method = "SET";
            $parameters = [[$idQueue, PDO::PARAM_INT],
                           [$field, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return isset($data[0]) && isset($data[0]['return_code']) ? [] : $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $attribute == "account" ? $this->getAccount()->toArray() : $this->$attribute;
        }

        return $arr;
    }

    public function __toString()
    {
        $p = array_map(function ($var) {
            return "'" . $var . "'";
        }, get_object_vars($this));

        return implode(',', $p);
    }
}
