<?php namespace Stage\Support;

use Exception;
use PDO;
use Stage\Stage;

class Post
{
    /**
     * changed
     *
     * @param int $page
     * @param int $perPage
     * @return array
     * @throws Exception
     */
    public static function changed($page = 1, $perPage = 20, $field = 0, $filter = "")
    {
        $from = ($page-1) * $perPage;
        $to = $perPage;

        try {
            $name = "PUBLISH_POSTS_MGO";
            $method = "GET";
            $parameters = [[$field, PDO::PARAM_INT],
                [$filter, PDO::PARAM_STR],
                [$from, PDO::PARAM_INT],
                [$to, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * publishStart
     *
     * @return array
     * @throws Exception
     */
    public static function publishStart($syncType = null)
    {
        try {
            $name = "PUBLISH_POSTS_MGO";
            $method = "SET";
            $parameters = [];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * publishEnd
     *
     * @return array
     * @throws Exception
     */
    public static function publishEnd()
    {
        try {
            $name = "PUBLISH_POSTS_ENDS_MGO";
            $method = "SET";
            $parameters = [];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * postsToExecute
     *
     * @return array
     * @throws Exception
     */
    public static function postsToExecute()
    {
        try {
            $name = "PUBLISH_POSTS_TO_EXECUTE_MGO";
            $method = "GET";
            $parameters = [];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }
}
