<?php namespace Stage\Video\Channel\Metadata;

class Metadata
{

    /**
     * @var
     */
    private $title = "";

    /**
     * @var
     */
    private $description = "";

    /**
     * @var
     */
    private $image = "";

    /**
     * @var
     */
    private $imageTitle = "";

    /**
     * @var
     */
    private $imageAlt = "";

    /**
     * @var
     */
    private $keywords = "";

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('title','description','keywords','image','imageAlt','imageTitle');

    public function __construct()
    {
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getImageTitle()
    {
        return $this->imageTitle;
    }

    public function getImageAlt()
    {
        return $this->imageAlt;
    }

    public function getMetaDescription()
    {
        return $this->description;
    }

    public function getKeywords()
    {
        return $this->keywords;
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function setDescription($description)
    {
        $this->description = $description;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageTitle($imageTitle)
    {
        $this->imageTitle = $imageTitle;
    }

    public function setImageAlt($imageAlt)
    {
        $this->imageAlt = $imageAlt;
    }

    public function setKeywords($keywords)
    {
        $this->keywords = $keywords;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param  int  $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            $arr[$attribute] = $attribute == "title" || $attribute == "description" ? html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8') : $this->$attribute;
        }

        return $arr;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
