<?php namespace Stage\Video\Compose;

class PublishQuery extends Query
{
    const ALL           = 0;  // name, description and tags
    const TITLE         = 1;
    const DESCRIPTION   = 2;
    const MONTH         = 3;
    const YEAR          = 4;
    const TAGS          = 5;    // tags separated with % (tag1%tag2%...)
    const STATE         = 6;
    const RESOLUTION    = 7;
    const RATIO         = 8;
    const MIME_TYPE     = 9;
    const SIZE          = 10;
    const DURATION      = 11;
    const BITRATE       = 12;

    /**
     * @var int
     */
    public $idChannel = -1;

    /**
     * @var int
     */
    public $idPlaylist = -1;

    /**
     * @var
     */
    public $by;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $fromSize = 0;

    /**
     * @var
     */
    public $toSize = 0;


    /**
     * @var
     */
    public $order = 0;

    /**
     * @var
     */
    public $orderBy = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }

    public function __toString()
    {
        $p = array_map(function ($var) {
            return "'" . $var . "'";
        }, get_object_vars($this));

        return implode(',', $p);
    }
}
