<?php namespace Stage\Video\Compose;

class Query
{
    const ALL             = 0;  // name, description and tags
    const TITLE           = 1;
    const DESCRIPTION     = 2;
    const MONTH           = 3;
    const YEAR            = 4;
    const TAGS            = 1000;    // tags separated with % (tag1%tag2%...)
    const STATE           = 6;
    const RESOLUTION      = 7;
    const RATIO           = 8;
    const MIME_TYPE       = 9;
    const SIZE            = 10;
    const DURATION        = 11;
    const BITRATE         = 12;
    const WITH_PREROLL    = 13;
    const WITH_CAMPAIGNS  = 14;
    const WITH_POSTROLL   = 15;
    const WITH_MIDTROLL   = 16;

    const BY_UNPUBLISH_DATE     = 17;
    const BY_PUBLISH_DATE       = 18;

    const BY_COMPOSE_ID     = 100;
    const BY_VIDEO_ID       = 101;
    const BY_PROFILE_ID     = 102;
    const BY_PLAYLIST_ID    = 103;
    const BY_STATE_ID       = 104;
    const IN_PLAYLIST       = 105;

    const WITH_LABELS       = 106;
    const LABEL             = 107;

    const ORDER_BY_TITLE_ASC  = 11000;
    const ORDER_BY_TITLE_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC  = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    const ORDER_BY_PUBLISH_DATE_ASC  = 11002;
    const ORDER_BY_PUBLISH_DATE_DESC = 10002;

    /**
     * @var
     */
    public $by;

    /**
     * @var
     */
    public $sndBy = 0;

    /**
     * @var
     */
    public $trdBy = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $sndFilter = "";

    /**
     * @var
     */
    public $trdFilter = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $fromSize = 0;

    /**
     * @var
     */
    public $toSize = 0;

    /**
     * @var
     */
    public $idDirectory = 0;

    /**
     * @var
     */
    public $idPlaylist;

    /**
     * @var
     */
    public $isoLanguage = "";

    /**
     * @var
     */
    public $orderBy = 0;

    /**
     * @var
     */
    public $order = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }
}
