<?php namespace Stage\Video\Message;

use DateTime;

class MessageVideoComposed
{
    /**
     * @var
     */
    private $idVideoComposed = -1;

    /**
     * @var
     */
    private $isoLanguage;

    /**
     * @var
     */
    private $title = "";

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('idVideoComposed', 'isoLanguage', 'title');

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->idVideoComposed;
    }

    public function getIsoLanguage()
    {
        return $this->isoLanguage;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function setIdVideoComposed($id)
    {
        $this->idVideoComposed = (int)$id;
    }

    public function setIsoLanguage($isoLanguage)
    {
        $this->isoLanguage = $isoLanguage;
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "title" || $attribute == "description" || $attribute == "imageCaption") {
                $arr[$attribute] = html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8');
            } else if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return self
     */
    public static function createInstance($data)
    {
        $l10n = new self();
        $l10n->setIdVideoComposed($data['id_composed']);
        $l10n->setIsoLanguage($data['iso_language']);
        $l10n->setTitle(html_entity_decode($data['title'], ENT_COMPAT, 'UTF-8'));
        return $l10n;
    }

    public
    function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
