<?php namespace Stage\Video;

class Query
{
    const ALL           = 0;  // name, description and tags
    const NAME          = 1;
    const TAGS          = 1000;  // tags separated with % (tag1%tag2%...)
    const MONTH         = 3;
    const YEAR          = 4;
    const STATE         = 5;
    const RESOLUTION    = 6;
    const RATIO         = 7;
    const MIME_TYPE     = 8;
    const SIZE          = 9;
    const DURATION      = 10;
    const BITRATE       = 11;
    const LASTX         = 14;

    const BY_VIDEO_ID       = 100;
    const BY_COMPOSE_ID     = 101;
    const BY_PLAYLIST_ID    = 102;
    const BY_STATE_ID       = 103;
    const IN_COMPOSE        = 104;
    const IN_PLAYLIST       = 105;

    const ORDER_BY_NAME_ASC  = 11000;
    const ORDER_BY_NAME_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC  = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    const ORDER_BY_SIZE_ASC  = 11002;
    const ORDER_BY_SIZE_DESC = 10002;

    const ORDER_BY_EXTENSION_ASC  = 11003;
    const ORDER_BY_EXTENSION_DESC = 10003;

    const ORDER_BY_SECONDS_ASC  = 11004;
    const ORDER_BY_SECONDS_DESC = 10004;

    /**
     * @var
     */
    public $idDirectory = 0;

    /**
     * @var
     */
    public $by = 0;

    /**
     * @var
     */
    public $sndBy = 0;

    /**
     * @var
     */
    public $trdBy = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $sndFilter = "";

    /**
     * @var
     */
    public $trdFilter = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $fromSize = 0;

    /**
     * @var
     */
    public $toSize = 0;

    /**
     * @var
     */
    public $orderBy = 0;

    /**
     * @var
     */
    public $order = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }
}
