<?php namespace Stage\Video;

use PDO;
use Stage\Stage;

class Search
{
    /**
     *
     * addTerm
     *
     * @return array
     */
    public static function addTerm($idSearch, $term)
    {
        $name = "VIDEO_PUBLISH_SEARCH_SYNC_TERM";
        $method = "SET";
        $parameters = [[$idSearch, PDO::PARAM_STR],
                       [$term, PDO::PARAM_STR]];
        return Stage::esp($parameters, $name, $method);
    }

    /**
     *
     * saveSearch
     *
     * @return array
     */
    public static function saveSearch($idSync, $idRevSync, $hits, $lang, $updatedAt, $createdAt)
    {
        $name = "VIDEO_PUBLISH_SEARCH_SYNC";
        $method = "SET";
        $parameters = [[$idSync, PDO::PARAM_STR],
                       [$idRevSync, PDO::PARAM_STR],
                       [$hits, PDO::PARAM_INT],
                       [$lang, PDO::PARAM_STR],
                       [$updatedAt, PDO::PARAM_STR],
                       [$createdAt, PDO::PARAM_STR]];

        return Stage::esp($parameters, $name, $method);
    }

    /**
     * @return array
     * @throws \Exception
     */
    public static function searchTems()
    {
        $name = "VIDEO_PUBLISH_SEARCH_TO_SYNC";
        $method = "GET";
        $parameters = [];
        return Stage::esp($parameters, $name, $method);
    }

    /**
     * @param $idSearch
     * @return array
     * @throws \Exception
     */
    public static function terms($idSearch)
    {
        $name = "VIDEO_PUBLISH_SEARCH_TERMS_TO_SYNC";
        $method = "GET";
        $parameters = [[$idSearch, PDO::PARAM_STR]];
        return Stage::esp($parameters, $name, $method);
    }
}
