<?php namespace Stage\Video\Sticker;

use DateTime;
use Stage\Helper;

class Compose
{

    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idSticker;

    /**
     *
     * @var array
     */
    private $beginDate = "";

    /**
     *
     * @var
     */
    private $endDate = "";

    /**
     * @var
     */
    private $updateDate;

    /**
     *
     * @var string
     */
    private $registerDate = "";

    /**
     * Its a boolean
     * @var
     */
    private $fixed = false;

    /**
     * @var
     */
    private $value;

    /**
     * @var
     */
    private $name;

    /**
     * @var array
     */
    private $nameStripped;

    /**
     * @var array
     */
    private $total;

    /**
     * @var array
     */
    private $title;

    /**
     * @var array
     */
    private $description;

    /**
     * @var array
     */
    private $image;

    /**
     * @var array
     */
    private $imageAlign;

    /**
     * @var array
     */
    private $state;

    /**
     * @var array
     */
    private $position;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idSticker', 'beginDate', 'endDate', 'updateDate', 'registerDate', 'fixed', 'value', 'name', 'nameStripped', 'total', 'title', 'description', 'fixed', 'image', 'imageAlign', 'state', 'position');

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = array();

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    public function getIdSticker()
    {
        return $this->idSticker;
    }


    public function getBeginDate()
    {
        return $this->beginDate;
    }

    public function getEndDate()
    {
        return $this->endDate;
    }

    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    public function getFixed()
    {
        return $this->fixed;
    }

    public function getValue()
    {
        return $this->value;
    }

    public function getName()
    {
        return $this->name;
    }

    public function getNameStripped()
    {
        return $this->nameStripped;
    }

    public function getTotal()
    {
        return $this->total;
    }

    public function getTitle()
    {
        return $this->title;
    }

    public function getDescription()
    {
        return $this->description;
    }

    public function isFixed()
    {
        return (bool) $this->fixed;
    }

    public function getImage()
    {
        return $this->image;
    }

    public function getImageAlign()
    {
        return $this->imageAlign;
    }

    public function getState()
    {
        return $this->state;
    }

    public function getPosition()
    {
        return $this->position;
    }

    private function setId($id)
    {
        $this->id = (int)$id;
    }

    public function setIdSticker($id)
    {
        $this->idSticker = (int)$id;
    }

    public function setBeginDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->beginDate = "";
        } else {
            //$date = new DateTime($date);
            $this->beginDate = $date->format(DateTime::ATOM);
        }
    }

    public function setEndDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->endDate = "";
        } else {
            //$date = new DateTime($date);
            $this->endDate = $date->format(DateTime::ATOM);
        }
    }

    public function setRegisterDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->registerDate = "";
        } else {
            //$date = new DateTime($date);
            $this->registerDate = $date->format(DateTime::ATOM);
        }
    }

    public function setUpdateDate($date)
    {
        // Define how is the date format
        if ($date == null) {
            $this->updateDate = "";
        } else {
            //$date = new DateTime($date);
            $this->updateDate = $date->format(DateTime::ATOM);
        }
    }

    public function setFixed($fixed)
    {
        $this->fixed = (bool)$fixed;
    }

    public function setValue($value)
    {
        $this->value = (int)$value;
    }

    public function setName($name)
    {
        $this->name = $name;
    }

    public function setNameStripped($name)
    {
        $this->nameStripped = $name;
    }

    public function setTotal($total)
    {
        $this->total = (int)$total;
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function setDescription($desc)
    {
        $this->description = $desc;
    }

    public function setIsFixed($is)
    {
        $this->fixed = (bool)$is;
    }

    public function setImage($image)
    {
        $this->image = $image;
    }

    public function setImageAlign($imageAlign)
    {
        $this->imageAlign = $imageAlign;
    }

    public function setState($state)
    {
        $this->state = $state;
    }

    public function setPosition($position)
    {
        $this->position = (int)$position;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();
        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->attributes;
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($this->$attribute != null) {
                $arr[$attribute] = $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * createInstance
     *
     * @param $data
     * @return Compose
     */
    public static function createInstance($data)
    {
        if (isset($data[0])) {
            $data = $data[0];
        }

        $compose = new self();
        $compose->setId($data['id_composed']);
        $compose->setIdSticker($data['id_sticker']);
        $compose->setName(html_entity_decode($data['name'], ENT_COMPAT, 'UTF-8'));
        $compose->setNameStripped($data['name_stripped']);
        $compose->setTotal($data['total']);
        $compose->setTitle(html_entity_decode($data['title'], ENT_COMPAT, 'UTF-8'));
        $compose->setDescription(html_entity_decode($data['description'], ENT_COMPAT, 'UTF-8'));
        $compose->setIsFixed(isset($tag['fixed']) ? $tag['fixed'] : false);
        $compose->setValue(isset($tag['value']) ? $tag['value'] : -1); // It's the value associated with the position
        $compose->setImage($data['image']);
        $compose->setImageAlign($data['image_align']);
        $compose->setPosition($data['position']);
        $compose->setState($data['state']);


        if (Helper::isValidDate($data['begin_date'], "Y-m-d H:i:s")) {
            $compose->setBeginDate(new DateTime($data['begin_date']));
        }

        if (Helper::isValidDate($data['end_date'], "Y-m-d H:i:s")) {
            $compose->setEndDate(new DateTime($data['end_date']));
        }

        if (Helper::isValidDate($data['register_date'], "Y-m-d H:i:s")) {
            $compose->setRegisterDate(new DateTime($data['register_date']));
        }

        if (isset($tag['update_date']) && Helper::isValidDate($tag['update_date'], "Y-m-d H:i:s")) {
            $compose->setUpdateDate(new DateTime($tag['update_date']));
        }

        return $compose;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }
}
