<?php

use Stage\Account\Account;
use Stage\Account\Api;
use Stage\Account\User;
use Stage\Asset\Album\Album;
use Stage\Post\Dossier\Dossier;
use Stage\Asset\Asset;
use Stage\Post\Tag\Tag;
use Stage\Sps;
use Stage\Stage;
use Service\Connection;
use Stage\Post\Collection\Collection;
use Stage\StoredProcedure\Manager as StoredProcedureManager;

class AccountTest extends \PHPUnit_Framework_TestCase
{
    public function setUp()
    {
        $stageInstance = Stage::getInstance();

        $credentials = [
            'host' => "mysqldb",
            'dbname' => "StageAccount",
            'username' => "root",
            'password' => "secret"
        ];

        $clientCredentials = [
            'host' => "mysqldb",
            'dbname' => "bd1",
            'username' => "root",
            'password' => "secret"
        ];

        $tasksCredentials = [
            'host' => "mysqldb",
            'dbname' => "SkoiyTasks",
            'username' => "root",
            'password' => "secret"
        ];

        $default = new Connection($credentials);
        $client = new Connection($clientCredentials);
        $tasks = new Connection($tasksCredentials);
        $stageInstance->addConnection('default', $default);
        $stageInstance->addConnection('client', $client);
        $stageInstance->addConnection('tasks', $tasks);

        // 3. Set the Stage stored procedures
        $stageInstance->setSps(Sps::load());

        // Set the StoredProcedure\Manager instance
        $spm = StoredProcedureManager::getInstance();

        // Set the Stored Procedure Manager
        $stageInstance->setStoredProcedureManager($spm);

        try {
            $idAccount = 3;
            $account = Account::find($idAccount);

            // Get a Stage instance
            $stageInstance->setAccount($account);
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    public function tearDown()
    {
    }

    public function testUsersQuery()
    {
        $q = new \Stage\Account\UserQuery();
        $result = User::query($q);
        print_r($result->toArray());
    }

    public function testApiQuery()
    {
        $q = new \Stage\Account\ApiQuery();
        $q->idAccount = 3;
        $result = Api::query($q);
        print_r($result->toArray());
    }

    public function testAccountUsersQuery()
    {
        $q = new \Stage\Account\AccountUserQuery();
        $q->idAccount = 3;
        $result = Account::users($q);
        print_r($result->toArray());
    }

    public function testUserAccountsQuery()
    {
        $q = new \Stage\Account\AccountQuery();
        $q->idUser = 57;
        $result = User::accounts($q);
        print_r($result->toArray());
    }

}
