<?php

use Stage\Account\Account;
use Stage\Sps;
use Stage\Stage;
use Service\Connection;
use Stage\StoredProcedure\Manager as StoredProcedureManager;

class DownloadTest extends \PHPUnit_Framework_TestCase
{
    public function setUp()
    {
        $stageInstance = Stage::getInstance();

        $credentials = [
            'host' => "192.168.70.21",
            'dbname' => "StageAccount",
            'username' => "root",
            'password' => "secret"
        ];

        $clientCredentials = [
            'host' => "192.168.70.21",
            'dbname' => "bd1",
            'username' => "root",
            'password' => "secret"
        ];

        $tasksCredentials = [
            'host' => "192.168.70.21",
            'dbname' => "SkoiyTasks",
            'username' => "root",
            'password' => "secret"
        ];

        $default = new Connection($credentials);
        $client = new Connection($clientCredentials);
        $tasks = new Connection($tasksCredentials);
        $stageInstance->addConnection('default', $default);
        $stageInstance->addConnection('client', $client);
        $stageInstance->addConnection('tasks', $tasks);

        // 3. Set the Stage stored procedures
        $stageInstance->setSps(Sps::load());

        // Set the StoredProcedure\Manager instance
        $spm = StoredProcedureManager::getInstance();

        // Set the Stored Procedure Manager
        $stageInstance->setStoredProcedureManager($spm);

        try {
            $idAccount = 3;
            $account = Account::find($idAccount);

            // Get a Stage instance
            $stageInstance->setAccount($account);
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    public function tearDown()
    {
    }

    public function testCreateDownload()
    {
        $download = new \Stage\Asset\Download\Download();
        $download->setType("1");
        $download->setName("");
        $download->setCode("12345672");
        $download->setPassword(md5("secret"));
        $download->setEndDate((new DateTime)->format(DATE_ATOM));
        $download->setActive(1);
        $download->setTerm("term");
        $download->setDirectoryId(1);
        $download->setTag("tag");
        $download->setSystemTag("system_tag");
        $download->setSystemTagValue("system_tag_value");
        $download->setRoom("A");
        $download->setIdUser(3);
        $download->setOrderBy("order_by");

        try {
            $download->save();
        } catch (Exception $e) {
        }
    }

    public function testFindDownload()
    {
        $download = \Stage\Asset\Download\Download::find(1);

        try {
            print_r($download);
        } catch (Exception $e) {
        }
    }

    public function testDeleteDownload()
    {
        try {
            $download = \Stage\Asset\Download\Download::find(3);
            $download->delete();
        } catch (Exception $e) {
        }
    }

    public function testQueryDownload()
    {
        try {
            $query = new \Stage\Asset\Download\Query();
            $query->by = \Stage\Asset\Download\Query::ALL;
            $query->term = "";
            $query->filter = "";
            $query->from = 0;
            $query->to = 100;

            $downloads = \Stage\Asset\Download\Download::query($query);
            print_r($downloads);
        } catch (Exception $e) {
        }
    }

    public function testSizeOfDownloads()
    {
        try {
            $total = \Stage\Asset\Download\Download::sizeof();
            print_r($total);
        } catch (Exception $e) {
        }
    }
}
