<?php

use Stage\Account\Account;
use Stage\Sps;
use Stage\Stage;
use Service\Connection;
use Stage\StoredProcedure\Manager as StoredProcedureManager;

class SpriteTest extends \PHPUnit_Framework_TestCase
{
    public function setUp()
    {
        $stageInstance = Stage::getInstance();

        $credentials = [
            'host' => "192.168.70.21",
            'dbname' => "StageAccount",
            'username' => "root",
            'password' => "secret"
        ];

        $clientCredentials = [
            'host' => "192.168.70.21",
            'dbname' => "bd1",
            'username' => "root",
            'password' => "secret"
        ];

        $tasksCredentials = [
            'host' => "192.168.70.21",
            'dbname' => "SkoiyTasks",
            'username' => "root",
            'password' => "secret"
        ];

        $default = new Connection($credentials);
        $client = new Connection($clientCredentials);
        $tasks = new Connection($tasksCredentials);
        $stageInstance->addConnection('default', $default);
        $stageInstance->addConnection('client', $client);
        $stageInstance->addConnection('tasks', $tasks);

        // 3. Set the Stage stored procedures
        $stageInstance->setSps(Sps::load());

        // Set the StoredProcedure\Manager instance
        $spm = StoredProcedureManager::getInstance();

        // Set the Stored Procedure Manager
        $stageInstance->setStoredProcedureManager($spm);

        try {
            $idAccount = 3;
            $account = Account::find($idAccount);

            // Get a Stage instance
            $stageInstance->setAccount($account);
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    public function tearDown()
    {
    }

    public function testSpritePushToQueue()
    {
        $s = new \Stage\Sprite\Sprite();
        $s->setIdAccount(3);
        $s->setAccountToken("TOKEN3");
        $s->setIdVideo(3);
        $s->setVideo("video.mp4");
        $s->setSpritew(50);
        $s->setSpriteSpan(60);
        $s->setSpriteCol(5);
        $s->setWith(480);
        $s->setHeight(320);
        $s->setSeconds(258);
        $s->setAspecRatio("16:9");

        try {
            $return = $s->save();
            if (isset($return[0]) && isset($return[0]['return_code']) && $return[0]['return_code'] == 0) {
                echo "success";
            }
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    public function testSpriteNext()
    {
        try {
            $next = \Stage\Sprite\Sprite::next();
            print_r($next);
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }
}
